'Help 1.05                                                             
'                                                                                                         
'This include file displays an application help file created by GenHelp.exe                 
'just include it with your application program (#INCLUDE "appHelp.inc")                         
'displays the help as a treeview of headings, topics, and notes plus content 
'                                                                            
'GenHelp is used to prepare the application help file e.g. "myApp.ahp"
'include "appHelp.inc" and call help from your application with:              
'appHelp helpFile$, title$, h&, x0&, y0&
'  helpFile$: the help file, e.g. "myApp.ahp", created with genHelp.exe
'  title$: optional title ("Application Help" if left blank)                    
'  h&: optional handle of the calling application (modeless help window if present or nonzero)
'  x0&, y0&: optional coordinates relative to application window (requires passing handle, h&)
'----------------------------------------------------------------------------------------------
                                                          
#INCLUDE once "TPrint.inc"                                          
                                                  
%IDC_appHelp_Treeview       = 101                                                                                                             
%IDC_appHelp_Title          = 102
%IDC_appHelp_Gap            = 103
%IDC_appHelp_Textbox        = 104
%IDC_appHelp_Splitbar       = 105
%IDC_appHelp_StatusBar      = 106
%IDM_appHelp_Find           = 121
%IDM_appHelp_Next           = 122
%IDM_appHelp_Prev           = 123
%IDM_appHelp_Print          = 124                                                                   
%IDM_appHelp_ExpandTopics   = 125          
%IDM_appHelp_CollapseTopics = 126             
%IDM_appHelp_Popup          = 130
%IDM_appHelp_OtherPane      = 131
%IDM_appHelp_Quit           = 132
                                  
type appHelp_EdtOpt                                                                                          
   tabSpaces as long                                                        
   nWordWrap as long                                                    
end type

global appHelp_File            as string          'help file that is displayed
global appHelp_hDlg            as long            'help dialog handle
global appHelp_NumTree         as long            'number of tree items                                 
GLOBAL appHelp_Titles()        as string          'titles of tree items
global appHelp_Texts()         AS STRING          'text for tree items
global appHelp_treeLevel()     as long            'level = 0 for topic and 1 for note
global appHelp_treeHandles()   as long            'tree item handles in treeview order 
global appHelp_hItem           as long            'saved handle to last selected item               
global appHelp_wholeWord       as long            'whole word checkbox for find 
global origAppHelpTextboxProc  as long            'old proc handle for subclassing 
global hAppHelpMenu0           as long            'floating menu on treeview side
global hAppHelpMenu1           as long            'floating menu on textbox side
                           
sub appHelp(helpFile$, opt byval title$, byval h&, byref x0&, byref y0&)  
   'helpFile$: is the myHelp.ahp file that was created with genHelp.exe 
   'title: optional title ("Application Help" if left blank)                              
   'h&: optional handle of the calling application (required for default x0&, y0&)
   'x0&, y0&: optional cordinates of help window relative to the application window
   '---------------------------------------------------------------------------------------
   LOCAL x, y, xx, yy, nStyle, nCount AS long 
   appHelp_File = helpFile$                    
   if not isFile(helpFile$) then
      msgbox "No help available",%MB_ICONinformation, "Help File": exit sub
   end if
   dialog get loc h& to xx, yy 
   if ismissing(x0&) then x = 100 else x = x0&                                
   if ismissing(y0&) then y = 80 else y = y0&
   x = xx + x: y = yy + y
   nStyle = %WS_THICKFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX                                             
   if len(title$) = 0 then title$ = "Application Help"                  
   DIALOG NEW PIXELS, 0, title$, x, y, 640, 370, nStyle TO appHelp_hDlg
   nStyle = %TVS_EDITLABELS or %TVS_SHOWSELALWAYS OR %WS_TABSTOP                                            
   CONTROL ADD TREEVIEW, appHelp_hDlg, %IDC_appHelp_Treeview, "", 10, 5, 235, 325, nStyle
   control add label, appHelp_hDlg, %IDC_appHelp_Title, "", 250, 5, 370, 23
   control set color appHelp_hDlg, %IDC_appHelp_Title, %RGB_BLACK, %RGB_LIGHTGRAY
   control add label, appHelp_hDlg, %IDC_appHelp_Gap, "", 250, 28, 370, 12
   control set color appHelp_hDlg, %IDC_appHelp_Gap, %RGB_LEMONCHIFFON, %RGB_LEMONCHIFFON
   nStyle = %ES_AUTOVSCROLL OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY OR %WS_TABSTOP
   CONTROL ADD TEXTBOX, appHelp_hDlg, %IDC_appHelp_Textbox, "", 250, 40, 370, 290, nStyle
   control set color appHelp_hDlg, %IDC_appHelp_Textbox, %RGB_BLACK, %RGB_LEMONCHIFFON
   CONTROL ADD LINE, appHelp_hDlg, %IDC_appHelp_Splitbar, "", 245, 5, 5, 325, %SS_NOTIFY
   CONTROL ADD STATUSBAR, appHelp_hDlg, %IDC_appHelp_StatusBar, "", 0, 360, 700, 5 
   DIALOG SHOW MODal appHelp_hDlg, CALL appHelpProc
eND sub                                                      

CALLBACK FUNCTION appHelpProc()
   LOCAL iRet, w, v, dx, i, k, m, n, hFile, nStyle, wp, found, hParent, hBeginFind AS LONG                          
   LOCAL hInst, hIcon, hFont, hAccel, tabSpaces, tabUnits, nWordwrap, nPos, c1, c2 AS long
   local notWholeWord, hPopup as long 
   local j as word
   local s, ss, sParent AS STRING                                                                        
   local t AS SIZEL
   LOCAL pNMHDR AS NMHDR PTR, pt AS POINTAPI, tvHitInfo AS TV_HITTESTINFO
   STATIC wi, ht, x, y, x1, x2, w1, w2, u, h, yy, hh, hdc, index, hPopupMenu AS LONG
   STATIC splitting, hItem, hTreeview, hTextbox, lastWordwrap, lastFound, insideTextbox AS LONG
   static findMode, done, beginFind, lastIndex, hSelected, nFound, hLastFound as long
   static sItem, sFind, sText as string
   SELECT CASE CB.MSG                                                            
      CASE %WM_INITDIALOG 
         control handle CB.HNDL, %IDC_appHelp_Treeview to hTreeview                    
         control handle CB.HNDL, %IDC_appHelp_Textbox to hTextbox
                                                                                                           
         'put GenHelp icon in explorer
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "GenHelp", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND cb.hndl, %WM_SETICON, 0, hIcon                                                     
         
         'open and read the help file
         hFile = FREEFILE                                                             
         OPEN appHelp_File FOR BINARY AS hFile           
         GET hFile,, appHelp_numTree
          
         if appHelp_numTree <= 0 then
            msgbox "No help content",%MB_ICONinformation, "Help File"
            close hFile: DIALOG END CB.HNDL: exit function                               
         end if
         'read in the help file
         REDIM appHelp_Texts(1 TO appHelp_numTree)
         REDIM appHelp_Titles(1 TO appHelp_numTree)
         redim appHelp_TreeLevel(1 to appHelp_numTree)                     
         'redim appHelp_EditOpt(1 to appHelp_numTree)
         redim appHelp_TreeHandles(1 to appHelp_numTree)
         FOR i = 1 TO appHelp_numTree
            GET hFile,, j: appHelp_Texts(i) = SPACE$(j)                                                            
            GET hFile,, appHelp_Texts(i)
         NEXT i
         FOR i = 1 TO appHelp_numTree                                         
            GET hFile,, j: appHelp_Titles(i) = SPACE$(j)
            GET hFile,, appHelp_Titles(i)
         NEXT i
         get hFile,, appHelp_TreeLevel()                              
         CLOSE hFile
         appHelp_Treeview()

         'select first item in expanded form                                                                                                   
         for i = 1 to appHelp_numTree
            treeview set expanded cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
         next i
         treeview get root CB.HNDL, %IDC_appHelp_Treeview to hItem
         TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hItem              
         TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index              
         TREEVIEW GET text CB.HNDL, %IDC_appHelp_Treeview, hItem TO s
         control set text cb.hndl, %IDC_appHelp_Title, space$(5) + s
         CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_Texts(index)
         
         'set styles and fonts                                      
         FONT NEW "MS Sans Serif", 12 TO hFont
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Title, hFont
         FONT NEW "MS Sans Serif", 10 TO hFont                                    
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Textbox, hFont          
         CONTROL SET FONT cb.hndl, %IDC_appHelp_Treeview, hFont
         nStyle = %EC_LEFTMARGIN or %EC_RIGHTMARGIN
         CONTROL SEND cb.hndl, %IDC_appHelp_Textbox, %EM_SETMARGINS, nStyle, MAK(DWORD, 12, 12)                    
         
         'create popup menu for treeview control                      
         MENU NEW POPUP TO hAppHelpMenu0
         MENU ADD STRING, hAppHelpMenu0, "Find text" & $TAB & "CTRL+F", %IDM_appHelp_Find, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "Next" & $TAB & "F3", %IDM_appHelp_Next, %MF_ENABLED              
         MENU ADD STRING, hAppHelpMenu0, "Prev" & $TAB & "SHFT+F3", %IDM_appHelp_Prev, %MF_ENABLED
         menu add string, hAppHelpMenu0, "Find cancel" & $tab & "Escape", %IDM_appHelp_Quit, %mf_enabled
         MENU ADD STRING, hAppHelpMenu0, "-", 0, 0                                     
         'MENU ADD STRING, hAppHelpMenu0, "Expand topic", %IDM_appHelp_ExpandTopic, %MF_ENABLED                      
         'MENU ADD STRING, hAppHelpMenu0, "Collapse topic", %IDM_appHelp_CollapseTopic, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "Expand topics", %IDM_appHelp_ExpandTopics, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "Collapse topics", %IDM_appHelp_CollapseTopics, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu0, "-", 0, 0                                                                                            
         MENU ADD STRING, hAppHelpMenu0, "Print text" & $TAB & "CTRL+P", %IDM_appHelp_Print, %MF_ENABLED
         
         'create popup menu for textbox control
         MENU NEW POPUP TO hAppHelpMenu1  
         MENU ADD STRING, hAppHelpMenu1, "Find text" & $TAB & "CTRL+F", %IDM_appHelp_Find, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu1, "Next" & $TAB & "F3", %IDM_appHelp_Next, %MF_ENABLED
         MENU ADD STRING, hAppHelpMenu1, "Prev" & $TAB & "SHFT+F3", %IDM_appHelp_Prev, %MF_ENABLED 
         menu add string, hAppHelpMenu1, "Find cancel" & $tab & "Escape", %IDM_appHelp_Quit, %mf_enabled
         MENU ADD STRING, hAppHelpMenu1, "-", 0, 0
         MENU ADD STRING, hAppHelpMenu1, "Print item" & $TAB & "CTRL+P", %IDM_appHelp_Print, %MF_ENABLED
         
         'define accelerator keys                  
         REDIM ac(1 TO 7) AS ACCELAPI
         ac(1).fvirt = %FVIRTKEY OR %FCONTROL
         ac(1).key   = %VK_F
         ac(1).cmd   = %IDM_appHelp_Find
         ac(2).fvirt = %FVIRTKEY                                                                                                
         ac(2).key   = %VK_F2
         ac(2).cmd   = %IDM_appHelp_OtherPane
         ac(3).fvirt = %FVIRTKEY
         ac(3).key   = %VK_F3
         ac(3).cmd   =  %IDM_appHelp_Next
         ac(4).fvirt = %FVIRTKEY OR %FShift
         ac(4).key   = %VK_F3
         ac(4).cmd   =  %IDM_appHelp_Prev
         ac(5).fvirt = %FVIRTKEY OR %FCONTROL        
         ac(5).key   = %VK_P
         ac(5).cmd   = %IDM_appHelp_Print  
         ac(6).fvirt = %FVIRTKEY
         ac(6).key   = %VK_F10
         ac(6).cmd   = %IDM_appHelp_Popup 
         ac(7).fvirt = %FVIRTKEY
         ac(7).key   = %VK_ESCAPE
         ac(7).cmd   = %IDM_appHelp_Quit
                                                                          
         ACCEL ATTACH CBHNDL, ac() TO hAccel

         STATUSBAR SET PARTS CB.HNDL, %IDC_appHelp_StatusBar, .65*wi, 9999
         s = "  Right click mouse (or F10) for menu options"
         statusbar set text CB.HNDL, %IDC_appHelp_StatusBar, 1, 0, s 

         'need to subclass textbox to right click my own menu, not the Windows built-in menu
         origAppHelpTextboxProc = SetWindowLong(hTextbox, %GWL_WNDPROC, CodePtr(subClass_AppHelp_Textbox))
         DIALOG POST CB.HNDL,%WM_USER+500, 0, 0                                                     
      CASE %WM_USER+500 'show dialog for first time                   
         'can show dialog here if needed
      CASE %WM_SIZE
          'resize controls 
         DIALOG GET CLIENT CB.HNDL TO wi, ht
         wp = wi - x - 20                                                               
         control get client CB.HNDL, %IDC_appHelp_Textbox to wp, h
         CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview TO w, h                         
         CONTROL GET LOC CB.HNDL, %IDC_appHelp_SplitBar TO x, y                 
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, wi - x - 37, y + 18
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Gap, wi - x - 37, y + 12              
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, wi - x - 20, ht - 65         
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w, ht - 40
         CONTROL SET SIZE CB.HNDL, %IDC_appHelp_SplitBar, 5, ht - 40                       
         STATUSBAR SET PARTS CB.HNDL, %IDC_appHelp_StatusBar, .65*wi, 9999
      CASE %WM_SetCursor
         'show horizontal arrows if cursor is over splitter control
         iRet = GetDlgCtrlID (CB.WPARAM)
         IF iRet = %IDC_appHelp_SplitBar THEN MOUSEPTR 9: FUNCTION = 1
         'monitors the 3 basic splitter bar mouse actions, lbuttondown, mousemove, lbuttonup
         SELECT CASE HI(WORD, CB.LPARAM)
            CASE %WM_LBUTTONDOWN
               'sets flag to say splitter action has started (no actual movement yet)
               IF iRet = %IDC_appHelp_SplitBar THEN
                  Splitting = 1
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Treeview  TO x1, y
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Treeview  TO w1, h
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_Textbox  TO x2, yy
                  CONTROL GET SIZE CB.HNDL, %IDC_appHelp_Textbox  TO w2, hh                   
                  CONTROL GET LOC  CB.HNDL, %IDC_appHelp_SplitBar  TO u, v: x = u
               END IF
            CASE %WM_MOUSEMOVE
               'resizes windows and moves splitter bar to match mouse position (if position has changed)
               IF splitting THEN
                  GetCursorPos pt               'pt has xy screen coordinates in pixels
                  ScreenToClient CB.HNDL, pt    'pt now has client coordinates in pixels
                  IF pt.x <> x THEN             'mouse position has changed... resize
                     dx = pt.x - x
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Treeview, x1, y                             
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Treeview, w1 + dx, h

                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Title, x2 + dx, y
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Title, w2 - dx - 17, 23
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Gap, x2 + dx, y + 23
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Gap, w2 - dx - 17, 12
                     
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_Textbox, x2 + dx, y + 35
                     CONTROL SET SIZE CB.HNDL, %IDC_appHelp_Textbox, w2 - dx, h - 35
                     CONTROL SET LOC  CB.HNDL, %IDC_appHelp_SplitBar, u + dx, y
                  END IF                                                                           
               END IF
            CASE %WM_LBUTTONUP
               'sets flag to say splitter action has ended
               Splitting = 0
         END SELECT     
     CASE %WM_NOTIFY 
         IF CB.NMID = %IDC_appHelp_Treeview THEN
            pNMHDR = CB.NMHDR                                               
            IF @pNMHDR.code = %TVN_SELCHANGEDW THEN                                       
               'directed here when treeview selection changes 
               treeview set bold CB.HNDL, %IDC_appHelp_Treeview, hSelected, 0
               TREEVIEW GET SELECT CB.HNDL, %IDC_appHelp_Treeview TO hItem               
               hSelected = hItem
               if hItem = 0 then exit function '... in process of exiting program                      
               treeview set bold CB.HNDL, %IDC_appHelp_Treeview, hItem, 0                         
               TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hItem TO index                 
               CONTROL SET TEXT CB.HNDL, %IDC_appHelp_Textbox, appHelp_texts(index)                     
               TREEVIEW GET text CB.HNDL, %IDC_appHelp_Treeview, hItem TO s               
               control set text cb.hndl, %IDC_appHelp_Title, space$(5) + s
               'update last two panels of the staturbar                                 
               TREEVIEW GET PARENT cb.hndl, %IDC_appHelp_Treeview, hItem TO hParent
               IF hParent THEN
                  TREEVIEW GET TEXT cb.hndl, %IDC_appHelp_Treeview, hParent TO sParent
                  s = sParent + " : " + s
               END IF
               STATUSBAR SET TEXT cb.hndl, %IDC_appHelp_Statusbar, 2, 0, s
               s = "Size: " + STR$(LEN(appHelp_texts(index)))
               STATUSBAR SET TEXT cb.hndl, %IDC_appHelp_Statusbar, 3, 0, s
            END IF                                                      
         END IF
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            case %IDC_appHelp_Textbox
               IF CB.CTLMSG = %EN_SETFOCUS THEN 'entering textbox
                  insideTextbox = 1
                  SendMessage hTextbox, %EM_SETSEL, -1, 0                
                  lastIndex = index
                  TREEVIEW SET BOLD CB.HNDL, %IDC_appHelp_Treeview, hItem, 1
                  CONTROL SEND CB.HNDL, %IDC_appHelp_Textbox, %EM_SETSEL, -1, 0                              
                  CONTROL SEND CB.HNDL, %IDC_appHelp_Textbox, %EM_SCROLLCARET , 0, 0
               ELSEIF CB.CTLMSG = %EN_KILLFOCUS THEN 'leaving textbox
                  insideTextbox = 0                                                                                          
                  TREEVIEW SET BOLD CB.HNDL, %IDC_appHelp_Treeview, hItem, 0          
                  TREEVIEW select CB.HNDL, %IDC_appHelp_Treeview, hItem
               end if
            case %IDM_appHelp_OtherPane 'directed here with F2 key
               if insideTextbox then
                  SendMessage hTextbox, %EM_SETSEL, -1, 0
                  TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hSelected           
                  treeview set bold CB.HNDL, %IDC_appHelp_Treeview, hSelected, 0
                  control set focus cb.hndl, %IDC_appHelp_Treeview                                  
                  insideTextbox = 0             
               else
                  control set focus cb.hndl, %IDC_appHelp_Textbox
               end if                                                              

            case %IDM_appHelp_Find
               s = "Enter text:": '''inputOpt = 2                                              
               sFind = appHelp_Input(hTextbox)        
               if len(sFind) = 0 then exit function                                                 
               sFind = lcase$(sFind)                                                           
               beginFind = 1: nPos = 1: done = 0: 
               appHelp_getTreeHandles
               dialog send cb.hndl, %WM_Command, %IDM_appHelp_Next, 0             
            case %IDM_appHelp_Next
               if len(sFind) = 0 then exit function
               done = 0
               do
               for i = beginFind to appHelp_numTree
                  treeview get user cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i) to k
                  sText = lcase$(appHelp_Texts(k))
                  SendMessage(hTextbox, %EM_GetSel, varptr(m), varptr(n))
                  if nPos = 0 then nPos = n
                  if nPos = 0 then nPos = nFound + 1
                  found = instr(nPos, sText, sFind): nFound = found                      
                  notWholeWord = 0
                  if found and appHelp_wholeWord then
                     c1 = 0: c2 = 0
                     if found > 1 then c1 = asc(sText, found - 1)
                     if found + len(sFind) <= len(sText) then c2 = asc(sText, found + len(sFind))
                     if (c1 >= 65 and c1 <= 90) or (c2 >= 65 and c2 <= 90) then notWholeWord = 1
                     if (c1 >= 97 and c1 <= 122) or (c2 >= 97 and c2 <= 122) then notWholeWord = 1
                     if (c1 >= 48 and c1 <= 57) or (c2 >= 48 and c2 <= 57) then notWholeWord = 1
                     if notWholeWord then found = 0                                                         
                  end if
                  if found then
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i)
                     treeview unselect cb.hndl, %IDC_appHelp_Treeview
                     treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
                     SetFocus hTextbox                          
                     SendMessage hTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1      
                     SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                     hSelected = appHelp_treeHandles(i): hLastFound = hSelected: insideTextbox = 1
                     beginFind = i: lastFound = nFound: nPos = 0
                     exit function                                    
                  elseif notWholeWord then 'no more found for this treeView item, search the next item
                     if nFound + len(sFind) <= len(sText) then 'keep searching this treeView item
                        nPos = nFound + 1: beginFind = i: exit for
                     end if                              
                  end if
                  nPos = 1: if i = appHelp_numTree then done = 1                                           
                  treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 0                 
               next i
               loop until found or done
               if found = 0 then
                  if lastFound = 0 then 
                     msgbox "None found", , sFind                 
                     control set focus cb.hndl, %IDC_appHelp_Treeview 
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(index)                                              
                     exit function
                  end if                                                           
                  msgbox "No more found", , sFind
                  treeview select cb.hndl, %IDC_appHelp_Treeview, hLastFound
                  treeview unselect cb.hndl, %IDC_appHelp_Treeview
                  treeview set bold cb.hndl, %IDC_appHelp_Treeview, hLastFound, 1
                  SendMessage hTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
                  SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                  nPos = 0
               end if                               
            case %IDM_appHelp_Prev
               if len(sFind) = 0 then exit function 
               done = 0
               do
               for i = beginFind to 1 step -1
                  treeview get user cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i) to k
                  sText = lcase$(appHelp_Texts(k))
                  SendMessage(hTextbox, %EM_GetSel, varptr(m), varptr(n))
                  if nPos = 0 then nPos = len(sText) - m                      
                  if nPos = 0 then nPos = len(sText) - nFound
                  found = instr(-nPos, sText, sFind): nFound = found
                  notWholeWord = 0                                    
                  if found and appHelp_wholeWord then                                       
                     c1 = 0: c2 = 0
                     if found > 1 then c1 = asc(sText, found - 1)
                     if found + len(sFind) <= len(sText) then c2 = asc(sText, found + len(sFind))
                     if (c1 >= 65 and c1 <= 90) or (c2 >= 65 and c2 <= 90) then notWholeWord = 1
                     if (c1 >= 97 and c1 <= 122) or (c2 >= 97 and c2 <= 122) then notWholeWord = 1
                     if (c1 >= 48 and c1 <= 57) or (c2 >= 48 and c2 <= 57) then notWholeWord = 1
                     if notWholeWord then found = 0
                  end if
                  if found then
                     treeview select cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i)                                   
                     treeview unselect cb.hndl, %IDC_appHelp_Treeview                    
                     treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
                     SetFocus hTextbox            
                     SendMessage hTextbox, %EM_SetSel, found - 1, found + len(sFind) - 1                           
                     SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                     hSelected = appHelp_treeHandles(i): hLastFound = hSelected: insideTextbox = 1
                     beginFind = i: lastFound = nFound: nPos = 0
                     exit function                                                 
                  elseif notWholeWord then 'no more found for this treeView item, search the next item                   
                     if len(sText) - nFound >= 1 then 'keep searching this treeView item
                        nPos = len(sText) - nFound: beginFind = i: exit for                                         
                     end if                                    
                  end if                                                                         
                  nPos = 1: if i = 1 then done = 1
                  treeview set bold cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 0                          
               next i
               loop until found or done                                                                             
               if found = 0 then
                  msgbox "No more found", , sFind
                  treeview select cb.hndl, %IDC_appHelp_Treeview, hLastFound
                  treeview unselect cb.hndl, %IDC_appHelp_Treeview                                      
                  treeview set bold cb.hndl, %IDC_appHelp_Treeview, hLastFound, 1
                  SendMessage hTextbox, %EM_SetSel, lastFound - 1, lastFound + len(sFind) - 1
                  SendMessage hTextbox, %EM_ScrollCaret, 0, 0
                  nPos = 0
                  'sleep 4000
               end if
                
            case %IDM_appHelp_Print                                    
               if len(appHelp_Texts(index)) then appHelp_PrintItem
            case %IDM_appHelp_ExpandTopics
               for i = 1 to appHelp_numTree                                                                        
                  treeview set expanded cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 1
               next i
            case %IDM_appHelp_CollapseTopics   
               for i = 1 to appHelp_numTree
                  treeview set expanded cb.hndl, %IDC_appHelp_Treeview, appHelp_treeHandles(i), 0                              
               next i                                           
            case %IDM_appHelp_Popup 'directed here by F10                                         
               if insideTextbox then 
                  n = hAppHelpMenu1: control get loc CB.HNDL, %IDC_appHelp_Textbox to x, y
               else
                  n = hAppHelpMenu0: control get loc CB.HNDL, %IDC_appHelp_Treeview to x, y
               end if
               dialog get loc cb.hndl to i, k                                                 
               x = i + x + 40: y = k + y + 50                                             
               TrackPopupMenu n, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, x, y, 0, CB.HNDL, BYVAL %NULL                             
            case %IDM_appHelp_Quit
               if len(sFind) then
                  SendMessage hTextbox, %EM_SETSEL, -1, 0
                  sFind = "": exit function
               else
                  dialog end cb.hndl
               end if
         end select                                                             
      CASE %WM_CONTEXTMENU 'treeview popup menu                                                            
         IF CB.WPARAM = hTreeview THEN
            pt.x = LO(INTEGER, CB.LPARAM): pt.y = HI(INTEGER, CB.LPARAM)     
            x = pt.x: y = pt.y
            ScreenToClient CB.WPARAM, pt
            tvHitInfo.pt = pt                                                              
            tvHitInfo.flags = %TVHT_ONITEMLABEL                                                                      
            hPopup = SendMessage(hTreeview, %TVM_HITTEST, 0, VARPTR(tvHitInfo))
            IF hPopup = 0 THEN EXIT FUNCTION
            TREEVIEW SELECT CB.HNDL, %IDC_appHelp_Treeview, hPopup
            TREEVIEW GET USER CB.HNDL, %IDC_appHelp_Treeview, hPopup TO index
            TrackPopupMenu hAppHelpMenu0, %TPM_LEFTALIGN OR %TPM_LEFTBUTTON, x, y, 0, CB.HNDL, BYVAL %NULL
         END IF
      CASE %WM_SYSCOMMAND                                            
         IF CB.CTL = %SC_CLOSE THEN
            dialog end cb.hndl
         end if                                                                                                   
   end select  
end function                                                                                                                                 
             
FUNCTION appHelp_Input(BYVAL hParent as long) AS STRING
   'input function for entering text to find within help file 
   '-----------------------------------------------------------------------------
   LOCAL hInput, hdc, nStyle, hFont, numLines, ht, wi, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, s, appHelp_InputStr AS STRING                                              
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU 
   DIALOG NEW PIXELS, hParent, "Text to Find", , , 250, 110, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)                                          
   s = "Enter text: "
   control add label, hInput, 0, s, 5, 10, 70, 15    
   CONTROL ADD TEXTBOX, hInput, 9999, "",75, 10, 160, 20
   s = "Whole word"                                        
   control add checkbox, hInput, 9998, s, 10, 45, 100, 15
   control set check hInput, 9998, 1 
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", 140, 70, 60, 30
   DIALOG SET USER hInput, 1, VARPTR(appHelp_InputStr)
   DIALOG SHOW MODAL hInput, CALL appHelp_InputProc
   FUNCTION = TRIM$(appHelp_InputStr)                             
END FUNCTION

CALLBACK FUNCTION appHelp_InputProc()
   local nCheck as long
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
         control set check cb.hndl, 9998, 1                                                 
      CASE %WM_COMMAND
         if cb.ctl = %IDOK then
            control get check cb.hndl, 9998 to nCheck
            if nCheck then appHelp_wholeWord = 1                             
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps
            DIALOG END CB.HNDL
         elseif CB.CTL = %IDCANCEl then
            DIALOG END CB.HNDL 
         end if 
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN 
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

sub appHelp_getTreeHandles()
   'get handles to the tree items in the order of the expanded tree
   local i, n, hItem, hTopic, lastItem as long                                     
   treeview get count appHelp_hDlg, %IDC_AppHelp_Treeview to appHelp_numTree      
   redim appHelp_treeHandles(1 to appHelp_numTree)
   treeview get root appHelp_hDlg, %IDC_AppHelp_Treeview to hItem: hTopic = hItem 
   lastItem = 0: appHelp_treeHandles(1) = hItem                 
   for i = 2 to appHelp_numTree
      if lastItem = 0 then 'last item was a parent
         treeview get child appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic to hItem: lastItem = 1
         if hItem = 0 then 'no children, get next parent
            treeview get next appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic to hTopic: lastItem = 0         
         end if
      else 'last item was a child
         treeview get next appHelp_hDlg, %IDC_AppHelp_Treeview, hItem to hItem: lastItem = 1                                  
         if hItem = 0 then 'no more children, get next parent
            treeview get next appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic to hTopic: lastItem = 0 
         end if                                 
      end if
      if lastItem = 0 then hItem = hTopic
      appHelp_treeHandles(i) = hItem
   next i                                                 
end sub

SUB appHelp_Treeview()
   'redraw treeview using tree Levels, and help titles
   LOCAL hTopic, hItem, hFirst, i, j, k, n, index AS LONG
   LOCAL s AS STRING
   TREEVIEW RESET appHelp_hDlg, %IDC_appHelp_Treeview 
   FOR i = 1 TO appHelp_numTree
      j = appHelp_treeLevel(i)
      s = appHelp_Titles(i)
      IF j THEN 'treeview item is a note
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_AppHelp_Treeview, hTopic, %TVI_LAST, 0, 0, s TO hItem 
         TREEVIEW SET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem, i 
         appHelp_treeHandles(i) = hItem                                                                                   
      ELSE 'treeview item is a topic
         TREEVIEW INSERT ITEM appHelp_hDlg, %IDC_appHelp_Treeview, 0, %TVI_LAST, 0, 0, s TO hTopic
         TREEVIEW SET USER appHelp_hDlg, %IDC_appHelp_Treeview, hTopic, i 
         appHelp_treeHandles(i) = hTopic
      END IF
   NEXT i                                                     
END SUB                                              

FUNCTION subClass_appHelp_Textbox(BYVAL hWnd&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   LOCAL n, x, y AS LONG                                                                                        
   local pt AS POINTAPI                                                                                  
   SELECT CASE wMsg&
      Case %WM_ContextMenu                                                                                                     
         'this routine replaces the Windows built-in right click menu
         'WM_ContextMenu returns xy coordinates of mouse
         pt.x = LOWRD(lParm&): pt.y = HIWRD(lParm&)
         TrackPopupMenuEx hAppHelpMenu1, 0, pt.x, pt.y, appHelp_hDlg, BYVAL 0
         Function = 0 : Exit Function                                       
   END SELECT
   ' Pass the message on to the original window procedure                            
   FUNCTION = CallWindowProc(origAppHelpTextboxProc, hWnd&, wMsg&, wParm&, lParm&)
END FUNCTION

SUB appHelp_printItem()
   LOCAL m, n, k, i, j, mm, nLines, maxLines as long
   local tabCount, pgNo, multPgs, prn, hItem, index AS LONG
   LOCAL printerName, title, sTxt, s, sItem, temp, tabStr() AS STRING
   LOCAL leftMargin, topMargin, rightMargin, bottomMargin, pageWidth, pageHeight AS DOUBLE
   LOCAL x, wi, charHt, maxWidth AS DOUBLE
   LOCAL oTPrint AS iTPrint
   TREEVIEW GET select appHelp_hDlg, %IDC_appHelp_Treeview to hItem
   TREEVIEW GET USER appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO index
   TREEVIEW GET TEXT appHelp_hDlg, %IDC_appHelp_Treeview, hItem TO title
   LET oTPrint = CLASS "cTPrint"
   printerName = oTPrint.choosePrinter
   IF LEN(printerName) = 0 THEN EXIT SUB
   leftMargin = .75: topMargin = .25: rightMargin = .75: bottomMargin = .50
   oTPrint.setMargins(leftMargin, rightMargin, topMargin, bottomMargin)
   oTPrint.getPageSize(pageWidth, pageHeight)
   maxWidth = pageWidth - leftMargin - rightMargin
   oTPrint.newFont("Courier New", 9)
   sTxt = appHelp_Texts(index)                                          
   maxLines = oTPrint.getLines: n = 1: nLines = 4
   IF oTPrint.duplexSet THEN
      GOSUB appHelp_printPages: multPgs = ABS(multPgs) 'test for multiple pages
      oTPrint.duplexPrint(multPgs + 1)
   END IF
   prn = 1
   wi = oTPrint.getTextWidth("Page 1")
   oTPrint.beginDoc("appHelp")

   oTPrint.beginPage
   oTPrint.newFont("Courier New", 12, "u")
   oTPrint.printText(title, leftMargin, topMargin)
   oTPrint.newFont("Courier New", 9)
   oTPrint.printText("Page 1", pageWidth - rightMargin - wi, topMargin) 
   oTPrint.getCharSize(x, charHt)
   oTPrint.setPos(leftMargin, 4 * charHt)

   n = 1: nLines = 4: pgNo = 1
   GOSUB appHelp_printPages
   oTPrint.closePage
   oTPrint.closeDoc
   EXIT SUB

   appHelp_printPages:
      DO
         k = INSTR(n, sTxt, CHR$(13, 10))
         IF k THEN
            temp = MID$(sTxt, n, k - n): INCR k
         ELSE
            temp = MID$(sTxt, n): k = LEN(sTxt)
         END IF

         tabCount = PARSECOUNT(temp, CHR$(9))
         IF tabCount > 1 THEN 'process tabs
            REDIM tabStr(1 TO tabCount)
            PARSE temp, tabStr(), CHR$(9)
            temp = ""
            FOR i = 1 TO tabCount - 1
               s = SPACE$(8)
               j = 8 - (LEN(tabStr(i)) MOD 8)
               IF j THEN s = SPACE$(j)
               temp = temp + tabStr(i) + s
            NEXT i
            temp = temp + tabStr(tabCount)
         END IF
                                                    
         x = oTPrint.getTextWidth(temp)
         IF x <= maxWidth THEN 'print the line
            IF prn THEN oTPrint.printText(temp)
            INCR nLines
         ELSE 'else temp is too long... must break into lines
            DO
               s = oTPrint.truncate(temp, maxWidth)
               m = INSTR(-1, s, ANY " -,;:.()[]{}<>~/|\=")
               mm = INSTR(MID$(s, m, 1), ANY "([{<")
               IF prn THEN oTPrint.printText(TRIM$(LEFT$(temp, m - mm)))
               temp = MID$(temp, m - mm + 1): INCR nLines
               IF nLines > maxLines THEN GOSUB appHelp_nextPage
            LOOP WHILE m
         END IF
         IF nLines > maxLines THEN GOSUB appHelp_nextPage
         n = k + 1
      LOOP WHILE n < LEN(sTxt)
      RETURN

   appHelp_nextPage: 
      'print header for page
      IF multPgs <= 0 THEN multPgs = -1: RETURN
      oTPrint.closePage
      oTPrint.beginPage
      nLines = 4: INCR pgNo
      wi = oTPrint.getTextWidth("Page" + STR$(pgNo))
      oTPrint.newFont("Courier New", 12, "u")
      oTPrint.printText(title, leftMargin, topMargin)
      oTPrint.newFont("Courier New", 10)
      oTPrint.printText("Page" + STR$(pgNo), pageWidth - rightMargin - wi, topMargin)
      oTPrint.setPos(leftMargin, 4 * charHt)
      RETURN
END SUB                                                                               
                                                                                      
