#COMPILE EXE
#DIM ALL
#INCLUDE "wIN32api.inc"
#include "debug.inc"
#resource "calendar.pbr"

global hCal, today, thisMo, thisYr as long

FUNCTION PBMAIN()
   local s as string
   s = calendar()
   'msgbox s
END FUNCTION 

function Calendar(opt byval hParent as long) as string
   'returns double clicked date as string
   '----------------------------------------                                         
   local nStyle as long
   nStyle = %WS_POPUP OR %DS_MODALFRAME or %CS_DBLCLKS
   DIALOG NEW PIXELS, hParent, "Calendar Example", , , 160, 160, nStyle TO hCal
   dialog set color hCal, %rgb_black, %rgb_white
   DIALOG SHOW MODAL hCal, call CalProc                                                    
   FUNCTION = FORMAT$(thisMo, "00") + "-" + FORMAT$(today, "00") + "-" + trim$(str$(thisYr))  
END function                                
                                             
callback function CalProc()                                 
   local i, n, hFont, hFont1, hOrig, wi, ht, x, y, nCol, nRow, startDay, day as long                         
   local s, ti, sMonth as string                                  
   local ps AS PAINTSTRUCT
   static month, year, hdc as long
   static months() as string 
   SELECT CASE CB.MSG                              
      CASE %WM_INITDIALOG
         reDIM months(1 to 12)
         array assign months() = "January", "February", "March", "April", "May", "June", _
                                 "July", "August", "September", "October", "November", "December"
         today = VAL(MID$(DATE$, 4, 2))
         thisMo = VAL(LEFT$(DATE$, 2))                                                                       
         thisYr = VAL(RIGHT$(DATE$, 4))                                         
         month = thisMo: year = thisYr 
         dialog get size cb.hndl to wi, ht                                        
         font new "font0", 9,0,0,1 to hFont
         font new "font1", 12,0,0,1 to hFont1
         control add label, cb.hndl, 9102, "<", 2, 0, 20, 20, %SS_NOTIFY                                 
         control set font cb.hndl, 9102, hFont1
         control set color cb.hndl, 9102, %rgb_Black, %rgb_white
         control add label, cb.hndl, 9103, ">", 140, 0, 20, 20, %SS_NOTIFY or %ss_right
         control set font cb.hndl, 9103, hFont1
         control set color cb.hndl, 9103, %rgb_Black, %rgb_white
         ti = " Su Mo Tu We Th Fr Sa "
         control add label, cb.hndl, 9101, ti, 2, 25, 156, 15
         control set font cb.hndl, 9101, hFont
         control set color cb.hndl, 9101, %rgb_Black, %rgb_white
         control add line, cb.hndl, -1, "", 2, 40, wi-12, 1
         control add button, cb.hndl, %IDCancel, "x", 145, 145, 15, 15, %bs_pushlike 
         control add button, cb.hndl, 9104, "@", 129, 145, 15, 15, %bs_pushlike
         control add label, cb.hndl, 9105, trim$(str$(year)), 95, 145, 35, 15
         control set font cb.hndl, 9105, hFont
         control set color cb.hndl, 9105, %rgb_Black, %rgb_white
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500 
         InvalidateRect CBHNDL, BYVAL %NULL, 1 
      CASE %WM_LBUTTONDOWN
         'move window by dragging                                             
         SendMessage  CB.HNDL, %WM_NCLBUTTONDOWN, %HTCAPTION, 0
      case %WM_LBUTTONDBLCLK
         x = lo(word, cb.lparam)
         y = hi(word, cb.lparam)                                                                        
         nCol = (x-2)/21: nRow = (y-38)/15
         startDay = dayOfWeek(month, year, 1)
         do 
            incr n: 
            if n = 1 then day = 7 - startDay                                               
            if n = 2 then day = day + nCol
            if n > 2 then day = day + 7
         loop until n = nRow
         today = day: thisMo = month: thisYr = year 
         dialog end cb.hndl 
      CASE %WM_paint 'show dialog for first time 
         BeginPaint CBHNDL, ps 
         showMonth months(month)
         showDays month, year
         EndPaint CBHNDL, ps
      CASE %WM_COMMAND
         select case cb.ctl
            case %IDCANCEL: DIALOG END CB.HNDL
            case 9102
               decr month: if month < 1 then month = 12: decr year
               control set text cb.hndl, 9105, trim$(str$(year))
               InvalidateRect CBHNDL, BYVAL %NULL, 1          
            case 9103                                                                       
               incr month: if month > 12 then month = 1: incr year
               control set text cb.hndl, 9105, trim$(str$(year))                                    
               InvalidateRect CBHNDL, BYVAL %NULL, 1                           
            case 9104
               month = thisMo: year = thisYr   
               control set text cb.hndl, 9105, trim$(str$(year))                               
               InvalidateRect CBHNDL, BYVAL %NULL, 1                           
         end select  
      CASE %WM_DESTROY                     
   end select                                                                                             
end function 

sub showMonth(sMonth as string)
   local hdc, hFont1, hOrig, x, y, n as long
   local s as string
   hdc = GetDC(hCal)
   hFont1 = makeFont(hdc, "Courier New", 12)
   hOrig = SelectObject(hdc, hFont1)
   showText hdc, 20, 2, space$(12), %white, %blue      
   n = strSize(hdc, sMonth)
   x = 20 + (120 - n)/2: y = 2
   showText hdc, x, y, sMonth, %white, %blue
   SelectObject hdc, hOrig
end sub

sub showDays(mo as long, yr as long)                          
   local i, j, k, x, y, xx, yy, numDays, startDay, top, day as long 
   local hdc, hFont, hOrig, hBit, memdc as long 
   local sDay as string
   hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "todayBM")
   hdc = GetDC(hCal)
   hFont = makeFont(hdc, "Courier New", 9)                             
   hOrig = SelectObject(hdc, hFont)
   SetTextColor hdc, %rgb_black                                
   SetBkColor hdc, %Rgb_white
   numDays = daysInMonth(mo, yr)            
   startDay = dayOfWeek(mo, yr, 1)                       
   top = 50: k = 3                                               
   for i = 0 to 5
      for j = startDay to 6                                         
         incr day                                      
         sDay = rset$(trim$(str$(day)), 3)
         x = 2 + 21*j: y = top + 15*i - 7
         if day > numDays then sDay = space$(6)
         showText hdc, x, y, sDay 
         IF day = today AND mo = thisMo and yr = thisYr THEN 'need to circle today's date
            xx = x: yy = y 
         end if
         startDay = 0
      next j
   next i
   if yy then 'now draw the circle on today's date  
      memdc = CreateCompatibleDC(hdc)
      SelectObject memdc, hBit
      BitBlt hdc, xx+4, yy-3, 24, 24, memdc, 0, 0, %SRCAND
      DeleteDC memdc
      DeleteObject hBit 
   end if   
   SelectObject hdc, hOrig
end sub

SUB showText(hdc&, x&, y&, sText$, opt byval fg&, byval bg&)
   'hdc is after selecting in the font (if different from the system font)
   'optional fg and be are foreground and background colors
   '---------------------------------------------------------
   if fg& then SetTextColor hdc&, fg&
   if bg& then SetBkColor hdc&, bg&
   TextOut hdc&, x&, y&, BYVAL STRPTR(sText$), LEN(sText$)   
END SUB

FUNCTION dayOfWeek(month AS LONG, year AS LONG, day AS LONG) AS LONG
   'The AstroDay function defined here is a modified version
   '  of the Julian date formula used by astronomers.
   'http://support.microsoft.com/kb/q109451/
   'Sun = 0, Mon = 1, Tue = 2, ...
   '---------------------------------------------------------
   LOCAL astroDay AS LONG, y AS DOUBLE
   y = year + (month - 2.85) / 12
   astroDay = INT(INT(INT(367*y)-1.75*INT(y)+day) -0.75*INT(0.01*y))+1721119
   FUNCTION = (astroDay - 3) MOD 7
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION   

function strSize(hdc as long, s as string) as long        
   'hdc is after selecting in the font
   'return length of s in pixels
   '--------------------------------------------
   local sz AS ASCIIZ * 1024                             
   LOCAL t AS SIZEL                             
   sz = s: GetTextExtentPoint32 hDC, sz, LEN(sz), t
   function = t.cx
end function                                                   

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL descr AS STRING) AS LONG                                                    
   'specify descr = b for bold, u for underline, i for italic 
   '----------------------------------------------------------
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL BOLD AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(descr) THEN
      BOLD = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION
      