#COMPILE EXE                                                       
#DIM ALL                                                                          
'#debug display on                                                   
#INCLUDE "myBudget.inc"                     
#INCLUDE "win32api.inc"                         
#INCLUDE "appHelp.inc"                        
'#INCLUDE "debug.inc"                            
#RESOURCE "myBudget.pbr"                           
                                                 
$ver = "1.11"                     

FUNCTION PBMAIN()                
   LOCAL nStyle AS LONG
   LOCAL sTitle AS STRING
   sTitle = "myBudget - Ver " + $ver
   nStyle = %WS_CAPTION OR %WS_POPUP OR %DS_MODALFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX
   DIALOG default FONT "Arial", 10
   DIALOG NEW PIXELS, 0, sTitle, , , 800, 578, nStyle TO hMain
   nStyle = %WS_VSCROLL OR %LVS_SHOWSELALWAYS OR %LVS_REPORT OR _ '%LVS_SORTDESCENDING or _
            %LVS_SINGLESEL OR %LVS_NOSORTHEADER OR %WS_TABSTOP
   CONTROL ADD LISTVIEW, hMain, %IDC_MainListview, "", 20, 20, 640, 503, nStyle, %WS_EX_CLIENTEDGE
   CONTROL HANDLE hMain, %IDC_MainListview TO hMainListview
   LISTVIEW SET STYLEXX hMain, %IDC_MainListview, %LVS_EX_GRIDLINES OR %LVS_EX_FULLROWSELECT
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 1, "Date", 80, 0
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 2, "Transaction", 240, 2                              
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 3, "Amount", 80, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 4, "Paid by", 75, 2              
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 5, "Type", 70, 2
   LISTVIEW INSERT COLUMN hMain, %IDC_MainListview, 6, "Balance", 90, 2
   CONTROL ADD BUTTON, hMain, %IDC_AddTransX, "Add transX", 695, 30, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_EdtTransX, "Edit transX", 695, 80, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_DelTransX, "Delete transX", 695,130, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_ShowTrxCatgs, "Show catgs", 695, 330, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_showFunds, "Show funds", 695, 380, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_Analysis, "Analysis ", 695,430, 90, 40
   CONTROL ADD BUTTON, hMain, %IDC_ExitProg, "Exit program", 695,480, 90, 40
   addMenubar()
   CONTROL ADD STATUSBAR, hMain, %IDC_Statusbar, "", 0, 0, 0, 0
   STATUSBAR SET PARTS hMain, %IDC_Statusbar, 9999
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION                                                                   

CALLBACK FUNCTION mainProc()
   LOCAL i, j, k, n, fileNo, flags, x, y, iTrx AS LONG
   LOCAL s, year, mo, day, ti, f, filter, sDate AS STRING
   local amt as single
   SELECT CASE CB.MSG                                      
      CASE %WM_INITDIALOG
         'first, we must define the Windows data folder
         progFolder = specialFolder(%CSIDL_PROGRAM_FILES) + "\cgdSoftware\myBudget\"
         IF LCASE$(EXE.PATH$) = LCASE$(progFolder) THEN 'data in Windows special folder
            dataFolder = specialFolder(%CSIDL_COMMON_APPDATA) 
            dataFolder = dataFolder + "\cgdSoftware\myBudget\"      
         ELSE 'data in path of running program 
            dataFolder = EXE.PATH$
         END IF
         IF ISFOLDER(dataFolder) = 0 THEN MKDIR dataFolder
         helpFile = dataFolder + "myBudget.ahp"
         iniFile = dataFolder + "myBudget.ini"
         thisFile = dataFolder + "myBudget.bgt" 
         's = COMMAND$(1)     
         'IF LEN(s) THEN thisFile = s
         thisFile = COMMAND$(1)
         LISTVIEW RESET hMain, %IDC_MainListview
         if isfile(thisFile) then openThisFile                            
         STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 1, 0, thisFile
         DIM dataFiles(1 TO 4)
         DIM expAmts(1 TO 8), incAmts(1 TO 8)                
         DIM paidBy(1 to 6)
         ARRAY ASSIGN paidBy() = "Cash", "Check", "Credit card", "Debit card", "Govt assist", "None"
         FOR i = 1 TO 6: COMBOBOX ADD CB.HNDL, %IDC_PaidBy, paidBy(i): NEXT i
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500
         initialize()
         if numTransX then showTransX()
      case %wm_paint
      case %wm_setfocus
      CASE %WM_VSCROLL
      CASE %WM_NOTIFY
         SELECT CASE CB.NMID                                                      
            CASE %IDC_MainListview                                                                  
               SELECT CASE CB.NMCODE
                  case %NM_Click
                     LISTVIEW GET SELECT CB.HNDL, %IDC_MainListview TO iTrx
                  CASE %NM_dblclk 
                     LISTVIEW GET SELECT CB.HNDL, %IDC_MainListview TO iTrx 
                     if iTrx then showTrxCatgs(iTrx)
               end select
         end select      
      CASE %WM_COMMAND                          
         SELECT CASE CB.CTL
            CASE %IDM_New
               numTransX = 0
               LISTVIEW RESET hMain, %IDC_MainListview
               openIniFile(): numtransX = 0: thisFile = ""
               DIALOG SEND CB.HNDL, %WM_COMMAND, %IDM_SaveAs, 0
            CASE %IDM_Open
               ti = "Open File"
               flags = %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               filter = CHR$("myBudget (*.bgt)", 0, "*.bgt", 0, "All Files (*.*)", 0, "*.*", 0)
               DISPLAY OPENFILE CB.HNDL,,, ti, dataFolder, filter, "", "lbl", flags TO f
               IF LCASE$(PATHNAME$(EXTN, f)) = ".bgt" THEN
                  IF fileChanged THEN
                     s = "Current file has changed..." + $CRLF + "Save it before opening the new file?"
                     n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                     IF n = %IDYES THEN saveThisFile
                  END IF
                  LISTVIEW RESET hMain, %IDC_MainListview                                                                 
                  thisFile = f: openThisFile               
               END IF
               showTransX()
            CASE %IDM_Save
               IF LEN(thisFile) = 0 THEN DIALOG SEND CB.HNDL, %WM_COMMAND, %IDM_SaveAs, 0
               s = "Save this file now?"
               n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
               IF n = %IDYES THEN saveThisFile
            CASE %IDM_SaveAs                                                      
               ti = "Save File"
               flags = %OFN_OVERWRITEPROMPT or %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               filter = CHR$("Budget (*.bgt)", 0, "*.bgt", 0, "All Files (*.*)", 0, "*.*", 0)
               dataFolder = rtrim$(dataFolder, "\")
               DISPLAY SAVEFILE hMain,,, ti, dataFolder, filter, "", "bgt", flags TO f
               IF LEN(f) THEN
                  thisFile = f: saveThisFile
                  STATUSBAR SET TEXT CB.HNDL, %IDC_Statusbar, 1, 0, thisFile
               end if         
            CASE %IDM_Settings
               settings()
            case %IDM_Truncate                                      
               'save file to be truncated as archived file
               'truncate transactions to a certain date
               'the different funds are reset, but fund balance is preserved
               'cannot withdraw more than the fund balance
            case %IDM_Exit
               DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0   
            CASE %IDM_ShowTrxCatgs, %IDC_ShowTrxCatgs
               'DIALOG GET SIZE hShowTrxCatgs TO x, y
               IF x AND y THEN DIALOG END hShowTrxCatgs: EXIT FUNCTION
               LISTVIEW GET SELECT CB.HNDL, %IDC_MainListview TO iTrx
               IF iTrx THEN showTrxCatgs(iTrx)
            case %IDM_ShowFunds, %IDC_ShowFunds
               showFunds()
            case %IDM_Search
               search()   
            case %IDM_TrxFilters
               filters()   
            CASE %IDM_Analysis, %IDC_Analysis
            CASE %IDM_YRSummary
            CASE %IDM_AddTransX, %IDC_AddTransX
               addTransX()
            CASE %IDM_EdtTransX, %IDC_EdtTransX
               LISTVIEW GET SELECT CB.HNDL, %IDC_MainListview TO iTrx 
               IF iTrx THEN addTransX(iTrx)
            CASE %IDM_DelTransX, %IDC_DelTransX
               LISTVIEW GET SELECT hMain, %IDC_MainListview TO iTrx
               IF iTrx THEN
                  s = "Are you sure you want to delete this transaction?"
                  n = MSGBOX(s, %MB_ICONWARNING OR %MB_YESNO, "Delete transaction")
                  IF n = %IDYES THEN
                     n = trx(iTrx)
                     k = transX(n).trxType                         
                     amt = transX(n).amount
                     if k = 3 then fundBalance -= amt
                     if k = 4 then fundBalance += amt
                     for i = 1 to numTransX
                        if trx(i) > trx(iTrx) then decr trx(i)
                     next i
                     LISTVIEW DELETE ITEM hMain, %IDC_MainListview, iTrx
                     array delete trx(iTrx)                                               
                     array delete transX(n)
                     DECR numTransX: fileChanged = 1
                     computeBalances()
                  END IF
               END IF 
            CASE %IDC_ExitProg
               control get text cb.hndl, cb.ctl to s
               if s = "Back" then 
                  dialog set text cb.hndl, "myBudget - Ver " + $ver
                  control set text cb.hndl, cb.ctl, "Exit program"
                  showTransX(): if hFilter then dialog normalize hFilter: 'clearFilters()
               else   
                  DIALOG SEND CB.HNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
               end if
            CASE %IDM_Help
               appHelp helpFile
            CASE %IDM_About
               about()
            case %IDC_EnterKey
               if hSrch then dialog send hSrch, %WM_Command, %IDC_Search, 0   
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_DESTROY
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            IF fileChanged THEN
               s = "This file has been changed... do you want to save it?"
               n = MSGBOX(s, %MB_YESNOCANCEL OR %MB_ICONWARNING, "File Changed")
               IF n = %IDCANCEL THEN FUNCTION = 1: EXIT FUNCTION
               IF n = %IDYES THEN saveThisFile()
            END IF
         END IF
   END SELECT
END FUNCTION

SUB addMenubar()
   LOCAL i, n AS LONG
   LOCAL s AS STRING
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hFileMenu '-----------------------------------
   MENU ADD STRING, hFileMenu, "New", %IDM_New, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Open", %IDM_Open, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Save", %IDM_Save, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "SaveAs", %IDM_SaveAs, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0
   MENU ADD STRING, hFileMenu, "Print", %IDM_Print, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "Settings", %IDM_Settings, %MF_ENABLED  
   MENU ADD STRING, hFileMenu, "Truncate", %IDM_Truncate, %MF_ENABLED 
   MENU ADD STRING, hFileMenu, "Exit" & $TAB & "ALT+F4", %IDM_Exit, %MF_ENABLED
   MENU ADD STRING, hFileMenu, "-", 0, 0           
   FOR i = 1 TO numFiles
      IF ISFILE(dataFiles(i)) = 0 THEN ITERATE
      s = dataFiles(i): IF LEN(s) = 0 THEN EXIT FOR
      INCR n: dataFiles(n) = s
      s = "&" + TRIM$(STR$(n)) + "  " + PATHNAME$(NAMEX, s)
      MENU ADD STRING, hFileMenu, s, %IDM_Exit + i, %MF_ENABLED                    
   NEXT i
   numFiles = n
   MENU ADD POPUP, hMenu, "File", hFileMenu, %MF_ENABLED
   
   MENU NEW POPUP TO hTrxMenu '-----------------------------------
   MENU ADD STRING, hTrxMenu, "Add TransX", %IDM_AddTransX, %MF_ENABLED
   MENU ADD STRING, hTrxMenu, "Edit TransX", %IDM_EdtTransX, %MF_ENABLED
   MENU ADD STRING, hTrxMenu, "Del TransX", %IDM_DelTransX, %MF_ENABLED
   MENU ADD POPUP, hMenu, "TransX", hTrxMenu, %MF_ENABLED

   MENU NEW POPUP TO hTaskMenu '-----------------------------------
   MENU ADD STRING, hTaskMenu, "Show TrxCatgs", %IDM_ShowTrxCatgs, %MF_ENABLED 
   MENU ADD STRING, hTaskMenu, "Show Funds", %IDM_showFunds, %MF_ENABLED 
   MENU ADD STRING, hTaskMenu, "-", 0, 0
   MENU ADD STRING, hTaskMenu, "Search", %IDM_Search, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "Filters", %IDM_TrxFilters, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "Analysis", %IDM_Analysis, %MF_ENABLED
   MENU ADD STRING, hTaskMenu, "Yearly summary", %IDM_YrSummary, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Tasks", hTaskMenu, %MF_ENABLED

   MENU NEW POPUP TO hHelpMenu
   MENU ADD STRING, hHelpMenu, "Help" & $TAB & "F1", %IDM_Help, %MF_ENABLED
   MENU ADD STRING, hHelpMenu, "About", %IDM_About, %MF_ENABLED
   MENU ADD POPUP, hMenu, "Help", hHelpMenu, %MF_ENABLED
   MENU ATTACH hMenu, hMain

   REDIM ac(1 TO 2) AS ACCELAPI
   ac(1).fvirt  = %FVIRTKEY
   ac(1).key    = %VK_F1
   ac(1).cmd    = %IDM_Help
   ac(2).fvirt  = %FVIRTKEY
   ac(2).key    = %VK_RETURN
   ac(2).cmd    = %IDC_EnterKey        
   ACCEL ATTACH hMain, ac() TO hAccel
END SUB

SUB openIniFile()
   LOCAL i, fileNo AS LONG
   local s as string                                       
   fileNo = FREEFILE
   OPEN iniFile FOR INPUT access read AS fileNo
   INPUT# fileNo, maxExpenses, maxIncomes
   DIM expenses(1 TO maxExpenses)   
   DIM incomes(1 TO maxIncomes)
   FOR i = 1 TO maxExpenses
      INPUT# fileNo, s
      expenses(i).catgID = s 
      expenses(i).catgNo = i
   NEXT i
   FOR i = 1 TO maxIncomes
      INPUT# fileNo, s
      incomes(i).catgID = s 
      incomes(i).catgNo = i
   NEXT i
   CLOSE fileNo
   fileChanged = 0
END SUB                                            

SUB openThisFile()
   LOCAL i, j, m, n, fileNo AS LONG
   local numTrxCatgs1, numTrxCatgs2 as long
   LOCAL s AS STRING
   LOCAL ver AS STRING*4
   fileNo = FREEFILE                                       
   OPEN thisFile FOR inPUT AS fileNo
   input# fileNo, ver                                         
   INPUT# fileNo, maxExpenses, maxIncomes
   DIM expenses(1 TO maxExpenses)
   DIM incomes(1 TO maxIncomes)
   
   'first, read in the settings data
   FOR i = 1 TO maxExpenses
      INPUT# fileNo, expenses(i).catgID, expenses(i).catgNo, expenses(i).catgGoal, _
                     expenses(i).essn, expenses(i).fixd, expenses(i).auto
   NEXT i
   FOR i = 1 TO maxIncomes                                                                  
      INPUT# fileNo, incomes(i).catgID, incomes(i).catgNo, incomes(i).catgGoal, _
                     incomes(i).essn, incomes(i).fixd, incomes(i).auto
   NEXT i
   
   'now, read in the trans() data 
   INPUT# fileNo, numTransX
   if numTransX then
      DIM transX(1 TO numTransX)
      FOR i = 1 TO numTransX                               
         INPUT# fileNo, transX(i).date, transX(i).nameID, transX(i).amount, transX(i).paidBy, _
                        transX(i).trxType, transX(i).numTrxCatgs
         FOR j = 1 TO transX(i).numTrxCatgs
            INPUT# fileNo, transX(i).catg(j), transX(i).catgAmt(j)
            if transX(i).trxType = 2 then m = maxIncomes else m = maxExpenses 'changed to one level catgs               
            if transX(i).catg(j) > m then transX(i).catg(j) = 1               'changed to one level catgs
         NEXT j
      NEXT i
   end if

   CLOSE fileNo                                                                     
   fileChanged = 0: catgOrder()
   STATUSBAR SET TEXT hMain, %IDC_Statusbar, 1, 0, thisFile
END SUB

SUB saveThisFile()
   LOCAL i, j, m, n, fileNo AS LONG
   LOCAL s AS STRING
   fileNo = FREEFILE
   OPEN thisFile FOR OUTPUT AS fileNo
   WRITE# fileNo, $ver
   WRITE# fileNo, maxExpenses, maxIncomes
   
   'first, write the settings data
   FOR i = 1 TO maxExpenses
      WRITE# fileNo, TRIM$(expenses(i).catgID), expenses(i).catgNo, expenses(i).catgGoal, _
                     expenses(i).essn, expenses(i).fixd, expenses(i).auto 
   NEXT i
   FOR i = 1 TO maxIncomes                                                      
      WRITE# fileNo, TRIM$(incomes(i).catgID), incomes(i).catgNo, incomes(i).catgGoal, _
                     incomes(i).essn, incomes(i).fixd, incomes(i).auto
   NEXT i
                                                                                             
   'now, write the trans() data
   WRITE# fileNo, numTransX
   FOR i = 1 TO numTransX
      WRITE# fileNo, transX(i).date, TRIM$(transX(i).nameID), transX(i).amount, transX(i).paidBy, _
                     transX(i).trxType, transX(i).numTrxCatgs
      FOR j = 1 TO transX(i).numTrxCatgs
         WRITE# fileNo, transX(i).catg(j), transX(i).catgAmt(j)
      NEXT j
   NEXT i
   
   CLOSE fileNo
   fileChanged = 0 
END SUB

sub Initialize()
   local i, j, n as long 
   local s as string
   'create transXID() for fast data entry
   if numTransX then
      j = 1: dim transXID(1 to 1)
      transXID(1) = trim$(transX(1).NameID)
      for i = 2 to numTransX
         s = trim$(transX(i).NameID)
         n = binarySrch(s, transXID())
         if n < 0 then                                                  
            incr j: redim preserve transXID(1 to j)
            array insert transXID(abs(n)), s
         end if                                         
      next i
      numTransXID = j                                        
   end if
           
   'compute fundBalance   
   fundBalance = 0
   for i = 1 to numTransX 'get fundBalance
      if transX(i).trxType = 3 then
         fundBalance = fundBalance + transX(i).amount
      elseif transX(i).trxType = 4 then
         fundBalance = fundBalance - transX(i).amount
      end if
   next i
   
   'catgOrder()
end sub

sub showTransX() 'display main listview
   local i, n as long                                                                         
   local s as string
   listview reset hMain, %IDC_MainListview                                                        
   FOR i = 1 TO numTransX
      s = TRIM$(STR$(transX(i).date))                                
      s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
      LISTVIEW INSERT ITEM hMain, %IDC_MainListview, i, 0, s                       
      s = alignCol(hMainListview, TRIM$(transX(i).nameID), 220)                                
      LISTVIEW SET TEXT hMain, %IDC_MainListview, i, 2, s
      s = alignCol(hMainListview, trim$(FORMAT$(transX(i).amount, "0.00")), -70)
      LISTVIEW SET TEXT hMain, %IDC_MainListview, i, 3, s 
      n = transX(i).paidBy: if n and n <= 5 then s = paidBy(n) else s = ""
      LISTVIEW SET TEXT hMain, %IDC_MainListview, i, 4, s
      s = choose$(transX(i).trxType, "Expense", "Income", "To fund", "From fund")                                                    
      LISTVIEW SET TEXT hMain, %IDC_MainListview, i, 5, s
      listview set text hMain, %IDC_MainListview, i, 6, str$(i)
   NEXT i
   LISTVIEW SORT hMain, %IDC_MainListview, 1, DESCEND, MMDDYYYY                        
   'the balance field has been used above just to keep track of the effects of sorting
   'but now those balances must be copied to trx() and cleared for computeBalances() 
   dim trx(1 to numTransX)
   for i = 1 to numTransX
      listview get text hMain, %IDC_MainListview, i, 6 to s
      listview set text hMain, %IDC_MainListview, i, 6, ""
      trx(i) = val(s)
   next i   
   computeBalances()
end sub

'=========================================================================================
SUB showTrxCatgs(iTrx AS LONG)
   LOCAL nStyle AS LONG
   nStyle = %WS_CAPTION OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Categories", 100, 75, 206, 136, nStyle TO hShowTrxCatgs
   EnableMenuItem GetSystemMenu(hShowTrxCatgs, 0), %SC_CLOSE, %MF_ENABLED                                             
   nStyle = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %LVS_REPORT OR %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL
   CONTROL ADD LISTVIEW, hShowTrxCatgs, %IDC_TrxCatgs, "", 2, 0, 206, 136, nStyle, %WS_EX_CLIENTEDGE
   LISTVIEW SET STYLEXX hShowTrxCatgs, %IDC_TrxCatgs, %LVS_EX_GRIDLINES
   LISTVIEW INSERT COLUMN hShowTrxCatgs, %IDC_TrxCatgs, 1, "Category", 142, 0
   LISTVIEW INSERT COLUMN hShowTrxCatgs, %IDC_TrxCatgs, 2, "Amount", 60, 2
   DIALOG SET USER hShowTrxCatgs, 1, iTrx 'pass iTrx to callback
   DIALOG SHOW MODal hShowTrxCatgs CALL showTrxCatgsProc
END SUB

CALLBACK FUNCTION showTrxCatgsProc()
   LOCAL i, j, k, n, iTrx AS LONG
   local s as string
   LOCAL amt AS SINGLE
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG 
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500
         DIALOG GET USER CB.HNDL, 1 TO iTrx
         j = trx(iTrx): k = transX(j).trxType
         FOR i = 1 TO transX(j).numTrxCatgs
            n = transX(j).catg(i): amt = transX(j).catgAmt(i)           
            if k = 2 then n = incOrder(n) else n = expOrder(n)
            if k = 2 then s = incomes(n).catgID else s = expenses(n).catgID
            LISTVIEW INSERT ITEM CB.HNDL, %IDC_trxCatgs, i, 0, trim$(s)
            if amt then LISTVIEW SET TEXT CB.HNDL, %IDC_trxCatgs, i, 2, FORMAT$(amt, "0.00")
         NEXT i
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDCANCEL, %IDOK: DIALOG END CB.HNDL
         END SELECT                                                                           
   END SELECT
END FUNCTION                                                              

sub catgOrder()
   'order categories by catgNo as the index and value as the stored catg
   'add new catg (catgNo = 22) as 3rd stored catg so that expOrder(22) = 3
   '------------------------------------------------------------------------- 
   local i, n as long
   redim expOrder(1 to maxExpenses)
   for i = 1 to maxExpenses
      n = expenses(i).catgNo: expOrder(n) = i
   next i
   redim incOrder(1 to maxIncomes)
   for i = 1 to maxIncomes                                                        
      n = incomes(i).catgNo: incOrder(n) = i
   next i
end sub                                                     
     
'=========================================================================================
SUB showFunds()   
   LOCAL nStyle AS LONG
   nStyle = %WS_CAPTION OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Funds for myBudget", 100, 75, 500, 345, nStyle TO hShowFunds
   EnableMenuItem GetSystemMenu(hShowFunds, 0), %SC_CLOSE, %MF_ENABLED
   nStyle = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %LVS_REPORT OR %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL
   nStyle = %WS_VSCROLL OR %LVS_SHOWSELALWAYS OR %LVS_REPORT OR _ 
            %LVS_SINGLESEL OR %LVS_NOSORTHEADER OR %WS_TABSTOP
   CONTROL ADD LISTVIEW, hShowFunds, %IDC_ShowFunds, "", 5, 5, 492, 275, nStyle, %WS_EX_CLIENTEDGE 
   LISTVIEW SET STYLEXX hShowFunds, %IDC_ShowFunds, %LVS_EX_GRIDLINES
   LISTVIEW INSERT COLUMN hShowFunds, %IDC_ShowFunds, 1, "Date", 80, 0
   LISTVIEW INSERT COLUMN hShowFunds, %IDC_ShowFunds, 2, "Category", 150, 2
   LISTVIEW INSERT COLUMN hShowFunds, %IDC_ShowFunds, 3, "ToFrom", 75, 2
   LISTVIEW INSERT COLUMN hShowFunds, %IDC_ShowFunds, 4, "Amount", 80, 2
   LISTVIEW INSERT COLUMN hShowFunds, %IDC_ShowFunds, 5, "Total", 90, 2
   control add button, hShowFunds, %IDC_ByDate, "By Date", 100, 290, 90, 30
   control add button, hShowFunds, %IDC_ByCatg, "By Catg", 200, 290, 90, 30
   control add button, hShowFunds, %IDCancel, "Cancel", 330, 290, 90, 30
   DIALOG SHOW MODal hShowFunds CALL showFundsProc                            
END SUB                                                                                                            

CALLBACK FUNCTION showFundsProc
   LOCAL i, j, k, m, n, nType AS LONG 
   local s, sCatg, sLastCatg as string
   LOCAL amt, balance AS SINGLE
   static numFunds as long
   SELECT CASE CB.MSG                                                           
      CASE %WM_INITDIALOG
         for i = 1 to numTransX 'find transactions for funds                              
            if transX(i).trxType >= 3 then incr numFunds
         next i                                                             
         if numFunds <= 18 then 'resize when no scrollbar needed
            control set size cb.hndl, %IDC_ShowFunds, 492, 275
         end if      
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0                 
      CASE %WM_USER + 500
         for i = numTransX to 1 step -1                        
            j = trx(i)
            k = transX(j).trxtype
            nType = transX(j).trxType                               
            if ntype < 3 then iterate for
            incr m
            s = TRIM$(STR$(transX(j).date))
            s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)                         
            LISTVIEW INSERT ITEM cb.hndl, %IDC_ShowFunds, m, 0, s
            n = transX(j).catg(1): s = expenses(n).catgID
            s = alignCol(cb.hndl, trim$(s), 128)
            listview set text cb.hndl, %IDC_ShowFunds, m, 2, s         
            if nType = 3 then s = "To fund" else s = "From fund"
            listview set text cb.hndl, %IDC_ShowFunds, m, 3, s                               
            amt = transX(j).amount
            s = alignCol(cb.hndl, format$(amt, "0.00"), -70)
            listview set text cb.hndl, %IDC_ShowFunds, m, 4, s 
         next i
         DIALOG POST CB.HNDL, %WM_command, %IDC_ByDate, 0                           
      CASE %WM_COMMAND            
         SELECT CASE CB.CTL
            case %IDC_ByDate
               listview sort cb.hndl, %IDC_ShowFunds, 1, DESCEND, MMDDYYYY 
               for i = numFunds to 1 step -1
                  listview get text cb.hndl, %IDC_ShowFunds, i, 4 to s: amt = val(s)
                  listview get text cb.hndl, %IDC_ShowFunds, i, 3 to s
                  if s = "From fund" then amt = -amt
                  balance = balance + amt
                  s = alignCol(cb.hndl, format$(balance, "0.00"), -80)
                  listview set text cb.hndl, %IDC_ShowFunds, i, 5, s
               next i
               fundBalance = balance
            case %IDC_ByCatg
               listview sort cb.hndl, %IDC_ShowFunds, 2, DESCEND, MMDDYYYY
               sLastCatg = ""
               for i = numFunds to 1 step -1
                  listview get text cb.hndl, %IDC_ShowFunds, i, 2 to sCatg
                  if sCatg <> sLastCatg then balance = 0
                  sLastCatg = sCatg
                  listview get text cb.hndl, %IDC_ShowFunds, i, 4 to s: amt = val(s) 
                  listview get text cb.hndl, %IDC_ShowFunds, i, 3 to s
                  if s = "From fund" then amt = -amt
                  balance = balance + amt
                  s = alignCol(cb.hndl, format$(balance, "0.00"), -65)
                  listview set text cb.hndl, %IDC_ShowFunds, i, 5, s
               next i   
            CASE %IDCANCEL, %IDOK: DIALOG END CB.HNDL
         END SELECT
   END SELECT
END FUNCTION

'========================================================================================   
SUB addTransX(OPT BYVAL iTrx AS LONG)
   LOCAL i, n, nStyle AS LONG
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Add Transaction", , , 450, 375, nStyle TO hAddTransX
   nStyle = %WS_GROUP OR %WS_TABSTOP or %BS_notify
   control add frame, hAddTransX, -1, "Type", 10, 5, 225, 62
   CONTROL ADD OPTION, hAddTransX, %IDC_Opt1, "Expense", 20, 22, 75, 15, nStyle
   CONTROL ADD OPTION, hAddTransX, %IDC_Opt2, "Income", 20, 42, 75, 15, %BS_NOTIFY 
   CONTROL ADD OPTION, hAddTransX, %IDC_Opt3, "To fund", 120, 22, 75, 15, %BS_NOTIFY
   CONTROL ADD OPTION, hAddTransX, %IDC_Opt4, "From fund", 120, 42, 75, 15, %BS_NOTIFY
   CONTROL SET OPTION hAddTransX, %IDC_Opt1, %IDC_Opt1, %IDC_Opt4         
   CONTROL ADD BUTTON, hAddTransX, %IDC_TrxHelp, "?", 300, 20, 25, 25
   CONTROL ADD LABEL, hAddTransX, -2, "Date: ",       53, 83, 40, 20
   CONTROL ADD LABEL, hAddTransX, -1, "TransX ID: ",  23, 113, 65, 20
   CONTROL ADD LABEL, hAddTransX, -1, "TransX Amt: ",  13, 143, 70, 20
   CONTROL ADD TEXTBOX, hAddTransX, %IDC_Date, "",      90, 80, 80, 20
   CONTROL ADD IMGBUTTONX, hAddTransX, %IDC_CalendarImg, "calendarBM", 180, 80, 20, 20
   CONTROL ADD TEXTBOX, hAddTransX, %IDC_TransXID, "",  90, 110, 240, 20
   control add textbox, hAddTransX, %IDC_Dummy, "", 90, 85, 240, 20
   control set color hAddTransX, %IDC_Dummy, %rgb_gray, %rgb_white                        
   control hide hAddTransX, %IDC_Dummy                                         
   CONTROL ADD TEXTBOX, hAddTransX, %IDC_TransXAmt, "", 90, 140, 75, 20   
   CONTROL ADD LABEL, hAddTransX, -1, "Paid by: ", 200, 143, 50, 16
   nStyle = %CBS_DROPDOWNLIST or %WS_VSCROLL or %CBS_HASSTRINGS or %WS_tabstop
   CONTROL ADD COMBOBOX, hAddTransX, %IDC_PaidBy, paidBy(), 252, 140, 100, 140, nStyle
   CONTROL ADD LABEL, hAddTransX, %IDC_OptText, "Add category: ", 290, 174, 100, 16
   CONTROL ADD COMBOBOX, hAddTransX, %IDC_AddCatgs, catg(), 270, 190, 155, 200, nStyle
   CONTROL ADD BUTTON, hAddTransX, %IDC_RemoveCatg, "Remove", 270, 220, 70, 25
   nStyle = %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL OR %LVS_REPORT or %LVS_NOSORTHEADER OR %WS_TABSTOP
   CONTROL ADD LISTVIEW, hAddTransX, %IDC_TrxCatgs, "", 10, 190, 240, 95, nStyle, %WS_EX_CLIENTEDGE
   LISTVIEW SET STYLEXX hAddTransX, %IDC_TrxCatgs, %LVS_EX_GRIDLINES  OR %LVS_EX_FULLROWSELECT
   LISTVIEW INSERT COLUMN hAddTransX, %IDC_TrxCatgs, 1, "Category", 160, 0
   LISTVIEW INSERT COLUMN hAddTransX, %IDC_TrxCatgs, 2, "Amount", 76, 2 
   CONTROL ADD BUTTON, hAddTransX, %IDC_AddData, "Continue", 325, 280, 100, 30
   CONTROL ADD BUTTON, hAddTransX, %IDCANCEL, "Cancel", 325, 315, 100, 30
   DIALOG SET USER hAddTransX, 1, iTrx
   DIALOG SHOW MODAL hAddTransX CALL addTransXProc
END SUB

CALLBACK FUNCTION addTransXProc()
   LOCAL i, j, k, m, n, n1, n2, wi, maxCatgs, catgNo, nPaidBy, nType, nOpt AS LONG
   LOCAL s, ss, s1, s2, s3, t, sDate, sCatg AS STRING
   LOCAL amt AS double
   static iTrx, trxID, tr, tr0 as long
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG 
         DIALOG GET USER CB.HNDL, 1 TO iTrx   
         CONTROL SET TEXT CB.HNDL, %IDC_Date, DATE$                                         
         control handle cb.hndl, %IDC_TransXID to hTransXID                  
         control handle cb.hndl, %IDC_TransXAmt to hTransXAmt                 
         control handle cb.hndl, %IDC_TrxCatgs to hTrxCatgs
         SetFocus hTransXID
         tr = 1: tr0 = 1: trxID = 0: numTrxCatgs = 0
                                    
         'Subclass the listview control so we can receive %WM_LButtonDown and %WM_KeyDown messages
         OldLVProc = SetWindowLongW(GetDlgItem(CB.HNDL, %IDC_TrxCatgs), %GWL_WNDPROC, BYVAL CODEPTR(LV1Proc))
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500
         nOpt = %IDC_Opt1
         IF iTrx THEN 'editing the selected transX item 
            j = trx(iTrx): iTrx = -abs(iTrx)                                
            k = transX(j).trxType
            nOpt = choose(k, %IDC_Opt1, %IDC_Opt2, %IDC_Opt3, %IDC_Opt4)
            CONTROL SET OPTION cb.hndl, nOpt, %IDC_Opt1, %IDC_Opt4 
            nPaidBy = transX(j).paidBy
            CONTROL SET TEXT CB.HNDL, %IDC_AddData, "Continue"
            n = transX(j).date: s = TRIM$(STR$(n))
            s =  MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
            CONTROL SET TEXT CB.HNDL, %IDC_Date, s
            CONTROL SET TEXT CB.HNDL, %IDC_TransXID, transX(j).nameID
            CONTROL SET TEXT CB.HNDL, %IDC_TransXAmt, FORMAT$(transX(j).amount, "0.00")
            COMBOBOX SELECT CB.HNDL, %IDC_PaidBy, transX(j).paidBy
            LISTVIEW RESET CB.HNDL, %IDC_TrxCatgs
            numTrxCatgs = transX(j).numTrxCatgs
            for i = 1 to numTrxCatgs 'show the catgs for this transaction
               n = transX(j).catg(i): amt = transX(j).catgAmt(i)
               if k = 2 then 'incomes
                  n = incOrder(n): s = incomes(n).catgID 
               else 'expenses
                  n = expOrder(n): s = expenses(n).catgID 
               end if   
               LISTVIEW INSERT ITEM CB.HNDL, %IDC_trxCatgs, i, 0, trim$(s)
               if amt then LISTVIEW SET TEXT CB.HNDL, %IDC_trxCatgs, i, 2, FORMAT$(amt, "0.00")
            next i
         END IF
         iTrx = abs(iTrx)
         DIALOG POST CB.HNDL, %WM_COMMAND, nOpt, 0   '%IDC_Opt1, 0
         control set focus cb.hndl, %IDC_TransXID
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDC_TrxHelp
               appHelp helpFile, "Help for my Budget"
            CASE %IDC_Opt1, %IDC_Opt3, %IDC_Opt4
               'if nOpt = 1 then exit function
               nOpt = 1       
               COMBOBOX RESET CB.HNDL, %IDC_AddCatgs
               REDIM catg(1 TO maxExpenses)
               FOR i = 1 TO maxExpenses
                  catg(i) = expenses(i).catgID
                  COMBOBOX ADD CB.HNDL, %IDC_AddCatgs, catg(i)
               NEXT i                                                                
            CASE %IDC_Opt2
               nOpt = 2
               COMBOBOX RESET CB.HNDL, %IDC_AddCatgs
               REDIM catg(1 TO maxIncomes)
               FOR i = 1 TO maxIncomes
                  catg(i) = incomes(i).catgID
                  COMBOBOX ADD CB.HNDL, %IDC_AddCatgs, catg(i)                    
               NEXT i
            CASE %IDC_CalendarImg                                                                           
               sDate = calendar(CB.HNDL)
               IF LEN(sDate) THEN CONTROL SET TEXT CB.HNDL, %IDC_Date, sDate
            case %IDC_TransXID
               if cb.ctlmsg = %EN_change and iTrx >= 0 then
                  control get text cb.hndl, cb.ctl to s
                  s = lcase$(trim$(s))
                  if len(s) > 1 and numTransXID then 'finding after 2nd character
                     do 
                        ss = lcase$(left$(transXID(tr), len(s)))
                        if ss = s then trxID = tr: exit do else trxID = 0
                        incr tr: if tr > numTransXID and tr0 > 1 then tr = 1: tr0 = 1
                     loop until tr > numTransXID and tr0 = 1
                     
                     if trxID > 0 then
                        tr = trxID + 1: tr0 = tr                  
                        if tr > numTransXID then tr = 1: tr0 = 1                       
                        control hide cb.hndl, -2   
                        control hide cb.hndl, %IDC_CalendarImg
                        control hide cb.hndl, %IDC_Date                  
                        control normalize cb.hndl, %IDC_Dummy
                        control set text cb.hndl, %IDC_Dummy, transXID(trxID)
                     else
                        trxID = 0: tr = 1: tr0 = 1
                        control set text cb.hndl, %IDC_Dummy, ""                    
                        control normalize cb.hndl, -2     
                        control normalize cb.hndl, %IDC_CalendarImg
                        control normalize cb.hndl, %IDC_Date
                        control hide cb.hndl, %IDC_Dummy                        
                     end if                                                 
                  else
                     trxID = 0: tr = 1: tr0 = 1                                               
                     control set text cb.hndl, %IDC_Dummy, ""
                     control normalize cb.hndl, -2     
                     control normalize cb.hndl, %IDC_CalendarImg
                     control normalize cb.hndl, %IDC_Date
                     control hide cb.hndl, %IDC_Dummy
                  end if
               end if      
            case %IDC_PaidBy and cb.ctlmsg = %CBN_SELENDOK
               combobox get select cb.hndl, %IDC_PaidBy to nPaidBy
            CASE %IDC_AddCatgs AND CB.CTLMSG = %CBN_SELENDOK
               if numTrxCatgs = 4 then exit function                        
               CONTROL GET TEXT CB.HNDL, %IDC_AddCatgs TO s
               INCR numTrxCatgs
               LISTVIEW INSERT ITEM CB.HNDL, %IDC_TrxCatgs, numTrxCatgs, 0, trim$(s)
            CASE %IDC_RemoveCatg
               LISTVIEW GET SELECT CB.HNDL, %IDC_TrxCatgs TO n           
               IF n THEN
                  LISTVIEW DELETE ITEM CB.HNDL, %IDC_TrxCatgs, n
                  decr numTrxCatgs
               END IF
            CASE %IDCANCEL                                    
               hAddTransX = 0: DIALOG END CB.HNDL
            CASE %IDOK 'here from clicking Enter 
               k = GetFocus()
               if trxID then
                  control set text cb.hndl, %IDC_TransXID, transXID(trxID)
                  control normalize cb.hndl, -2     
                  control normalize cb.hndl, %IDC_CalendarImg
                  control normalize cb.hndl, %IDC_Date                
                  control hide cb.hndl, %IDC_Dummy
                  for i = 1 to numTransX 'find last transaction with that nameID
                     j = trx(i)                                                                    
                     if trim$(transX(j).nameID) = transXID(trxID) then
                        k = transX(j).trxType
                        n = choose(k, %IDC_Opt1, %IDC_Opt2, %IDC_Opt3, %IDC_Opt4)
                        CONTROL SET OPTION cb.hndl, n, %IDC_Opt1, %IDC_Opt4
                        CONTROL SET TEXT CB.HNDL, %IDC_TransXAmt, FORMAT$(transX(j).amount, "0.00")
                        COMBOBOX SELECT CB.HNDL, %IDC_PaidBy, transX(j).paidBy
                        if transX(j).numTrxCatgs = 1 then
                           n = transX(j).catg(1): amt = transX(j).catgAmt(1)
                           if k = 2 then n = incOrder(n) else n = expOrder(n)
                           if k = 2 then s = incomes(n).catgID else s = expenses(n).catgID
                           LISTVIEW INSERT ITEM CB.HNDL, %IDC_trxCatgs, i, 0, s
                        end if
                        exit for    
                     end if
                  next i
                  control set focus cb.hndl, %IDC_TransXAmt
                  control send cb.hndl, %IDC_TransXAmt, %EM_SETSEL, 0, -1                       
                  trxID = 0: tr = 1: tr0 = 1: exit function
               elseif k = hTransXID then
                  control set focus cb.hndl, %IDC_TransXAmt: exit function                    
               elseif k = hTransXAmt then   
                  control set focus cb.hndl, %IDC_PaidBy: exit function
               elseif k = hTrxCatgs then
                  LISTVIEW GET TEXT CB.HNDL, %IDC_TrxCatgs, nRow, nCol TO s
                  amt = VAL(s): s = FORMAT$(amt, "0.00")
                  n = 8 - LEN(s): s = SPACE$(n) + s + SPACE$(n)                                          
                  LISTVIEW SET TEXT CB.HNDL, %IDC_TrxCatgs, nRow, nCol, s
                  sAmt = "": amtLocked = 1
               end if                                                                                       
            CASE %IDC_AddData 'clicked Continue, add this data to the main listview
               for i = 1 to 4
                  control get check cb.hndl, %IDC_Opt1 - 1 + i to k
                  if k then ntype = i: exit for
               next i
               IF iTrx THEN 'editing transaction, so first, delete it
                  n = trx(iTrx)
                  amt = transX(n).amount
                  if ntype = 3 then fundBalance -= amt
                  if nType = 4 then fundBalance += amt
                  for i = 1 to numTransX
                     if trx(i) > trx(iTrx) then decr trx(i)
                  next i
                  LISTVIEW DELETE ITEM hMain, %IDC_MainListview, iTrx
                  array delete trx(iTrx)                                               
                  array delete transX(n)
                  DECR numTransX
               end if
               INCR numTransX: if iTrx = 0 then iTrx = numTransX                      
               REDIM PRESERVE transX(1 TO numTransX)
               redim preserve trx(1 to numTransX)
               trx(numTransX) = numTransX
               control send hMain, %IDC_MainListview, %LVM_GETCOUNTPERPAGE, 0, 0 to n
               IF numTransX <= n THEN wi = 640 ELSE wi = 656 'allowance for scrollbar 
               CONTROL SET SIZE hMain, %IDC_MainListview, wi, 503 

               CONTROL GET TEXT CB.HNDL, %IDC_Date TO s
               IF LEN(s) = 0 THEN s = DATE$
               s1 = PARSE$(s, ANY"-/", 1): s2 = PARSE$(s, ANY"-/", 2): s3 = PARSE$(s, ANY"-/", 3)
               s1 = RIGHT$("0" + s1, 2): s2 = RIGHT$("0" + s2, 2): s3 = TRIM$(s3)
               IF LEN(s3) = 2 THEN s3 = "20" + s3 ELSE IF LEN(s3) = 0 THEN s3 = RIGHT$(DATE$, 4)
               transX(numTransX).date = VAL(s3 + s1 + s2)
               s = s1 + "-" + s2 + "-" + s3
               LISTVIEW INSERT ITEM hMain, %IDC_MainListview, numTransX, 0, s

               CONTROL GET TEXT CB.HNDL, %IDC_TransXID TO s: s = trim$(s)  ': ss = s
               n = binarySrch(s, transXID())
               if n < 0 then
                  t = "It appears that this is a new transaction name" + $crlf _
                    + "... add it to the transaction name list?"
                  k = msgbox(t, %MB_Iconquestion or %MB_Yesno, s)
                  if k = %IDyes then
                     incr numTransXID: redim preserve transXID(1 to numTransXID)
                     array insert transXID(abs(n)), s
                  else
                     decr numTransX
                     listview set text hMain, %IDC_MainListview, iTrx, 1, ""
                     control set focus cb.hndl, %IDC_TransXID
                     exit function    
                  end if     
               end if   
               transX(numTransX).nameID = s
               s = alignCol(hMainListview, s, 220)
               LISTVIEW SET TEXT hMain, %IDC_MainListview, numTransX, 2, s

               CONTROL GET TEXT CB.HNDL, %IDC_TransXAmt TO s: amt = ABS(VAL(s))
               if ntype = 4 and amt >= fundBalance then                             
                  msgbox "Fund is empty", %MB_iconinformation, "fundBalance = 0" 
                  amt = fundBalance: fundBalance = 0
               elseif ntype = 4 then
                  fundBalance = fundBalance - amt            
               end if
               transX(numTransX).amount = amt
               s = alignCol(hMainListview, FORMAT$(amt, "0.00"), -68)
               LISTVIEW SET TEXT hMain, %IDC_MainListview, numTransX, 3, s

               CONTROL GET TEXT CB.HNDL, %IDC_PaidBy TO s                        
               COMBOBOX GET SELECT CB.HNDL, %IDC_PaidBy TO nPaidby 
               IF nPaidBy THEN transX(numTransX).paidBy = nPaidBy
               LISTVIEW SET TEXT hMain, %IDC_MainListview, numTransX, 4, s
               
               s = choose$(nType, "Expense", "Income", "To fund", "From fund")
               transX(numTransX).trxType = nType                          
               LISTVIEW SET TEXT hMain, %IDC_MainListview, numTransX, 5, s
                                                          
               'now add the categories for this new transaction
               FOR i = 1 TO numTrxCatgs
                  LISTVIEW GET TEXT CB.HNDL, %IDC_TrxCatgs, i, 1 TO s: s = TRIM$(s)
                  LISTVIEW GET TEXT CB.HNDL, %IDC_TrxCatgs, i, 2 TO ss: amt = VAL(ss)
                  if nType = 2 then maxCatgs = maxIncomes else maxCatgs = maxExpenses
                  transX(numTransX).numTrxCatgs = numTrxCatgs
                  for j = 1 to maxCatgs
                     if ntype = 2 then sCatg = incomes(j).catgID else sCatg = expenses(j).catgID
                     IF TRIM$(sCatg) = s THEN 'found it, so store it
                        if nType = 2 then catgNo = incomes(j).catgNo else catgNo = expenses(j).catgNO
                        transX(numTransX).catg(i) = catgNo: transX(numTransX).catgAmt(i) = amt
                     end if
                  next j
               next i      
               
               for i = 1 to numTransX
                  listview set text hMain, %IDC_MainListview, i, 6, str$(trx(i))
               next i
               LISTVIEW SORT hMain, %IDC_MainListview, 1, DESCEND, MMDDYYYY
               'the balance field has been used above just to keep track of the effects of sorting
               'but now balances must be copied to trx() and cleared for computeBalances() below 
               for i = 1 to numTransX
                  listview get text hMain, %IDC_MainListview, i, 6 to s
                  listview set text hMain, %IDC_MainListview, i, 6, ""
                  trx(i) = val(s)                                                       
               next i
               computeBalances()
               fileChanged = 1            
               hAddTransX = 0: DIALOG END CB.HNDL
         END SELECT
      CASE %WM_DESTROY
         SetWindowLongW(GetDlgItem(CB.HNDL, %IDC_TrxCatgs), %GWL_WNDPROC, OldLVProc)
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN
            hAddTransX = 0
         END IF
   END SELECT
END FUNCTION

'listview subclass for adding transaction
FUNCTION LV1Proc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
   LOCAL c AS LONG            'number of rows per page
   LOCAL LVHT AS LVHITTESTINFO  'Contains information about a mouse clik on the ListView
   LOCAL sTemp AS WSTRING

   SELECT CASE AS LONG wMsg
      CASE %WM_LBUTTONDOWN

         lvht.pt.x = LO(WORD, lparam)   ' X coordinate of mouse left button down
         lvht.pt.y = HI(WORD, lparam)   ' Y coordinate of mouse left button down

         'Find the listview item and subitem at these X, Y coordinates
         SendMessage(hwnd, %LVM_SUBITEMHITTEST, BYVAL 0, BYVAL VARPTR(LVHT))
         IF lvht.iItem <> -1 THEN 'found listview cell
            CONTROL SET FOCUS hAddTransX, %IDC_TrxCatgs
            LISTVIEW UNSELECT hAddTransX, %IDC_TrxCatgs, nRow, nCol
            nRow = lVHT.iItem+1: nCol = LVHT.iSubItem+1
         ELSE
            EXIT FUNCTION
         END IF

         IF nCol = 1 THEN
            LISTVIEW SELECT hAddTransX, %IDC_TrxCatgs, nRow  ', nCol
         ELSEIF nCol = 2 THEN
            LISTVIEW SELECT hAddTransX, %IDC_TrxCatgs, nRow, nCol
         END IF

         'we handled this message, so we need to return a zero
         'and not call the the original listview callback.
         FUNCTION = 0: EXIT FUNCTION
      CASE %WM_KEYDOWN
      SELECT CASE AS LONG wParam
         CASE %VK_0 TO %VK_9, %VK_NUMPAD0 TO %VK_NUMPAD9, %VK_DECIMAL, %VK_BACK, %VK_DELETE, %VK_OEM_PERIOD
            IF nCol = 2 THEN 'enter data for goals
               IF wParam = %VK_DECIMAL OR wParam = %VK_OEM_PERIOD THEN
                  sAmt = sAmt + "."
               ELSEIF wParam = %VK_BACK THEN
                  sAmt = LEFT$(sAmt, LEN(sAmt) - 1)
               ELSEIF wParam = %VK_DELETE THEN
                  sAmt = ""
               ELSEIF wParam >= %VK_0 AND wParam <= %VK_9 THEN
                  sAmt = sAmt + TRIM$(STR$(wParam - %VK_0))
               ELSEIF wParam >= %VK_NUMPAD0 AND wParam <= %VK_NUMPAD9 THEN
                  sAmt = sAmt + TRIM$(STR$(wParam - %VK_NUMPAD0))
               END IF
               if len(sAmt) then amtLocked = 0
               LISTVIEW SET TEXT hAddTransX, %IDC_TrxCatgs, nRow, nCol, sAmt
            END IF
         CASE %VK_UP
            'navigate the listview selection up
            if amtLocked = 0 then revertBackAmts()
            if nRow > 1 then
               LISTVIEW UNSELECT hAddTransX, %IDC_TrxCatgs, nRow, nCol: decr nRow
            end if
         CASE %VK_DOWN
            'navigate the listview selection down
            if amtLocked = 0 then revertBackAmts()
            if nRow < numTrxCatgs then 
               LISTVIEW UNSELECT hAddTransX, %IDC_TrxCatgs, nRow, nCol: incr nRow
            end if
      END SELECT
      LISTVIEW SELECT hAddTransX, %IDC_TrxCatgs, nRow, nCol
      LISTVIEW VISIBLE hAddTransX, %IDC_TrxCatgs, nRow
      'we handled this message, so we need to return a zero
      'and not call the the original listview callback.
      FUNCTION = 0: EXIT FUNCTION
  END SELECT

  'if we did not handle this message, then pass the message on to the
  'original callback for the listview control.
  FUNCTION = CallWindowProcW(OldLVProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

SUB revertBackAmts()
   'revert back to already stored goal (was stored at %IDOK)
   IF nCol = 2 AND nOpt = 1 THEN
      LISTVIEW SET TEXT hAddTransX, %IDC_TrxCatgs, nRow, nCol, expAmts(nRow)
      sAmt = ""
   ELSEIF nCol = 2 AND nOpt = 2 THEN
      LISTVIEW SET TEXT hAddTransX, %IDC_TrxCatgs, nRow, nCol, incAmts(nRow)
      sAmt = ""
   END IF
END SUB

SUB computeBalances() 
   'compute balances for main listview
   LOCAL i, iTrx AS LONG                            
   LOCAL amt AS DOUBLE
   LOCAL s, sType, sPaidBy AS STRING                           
   STATIC balance AS DOUBLE
   'first, find where to start balances from
   FOR i = 1 to numTransX
      LISTVIEW GET TEXT hMain, %IDC_MainListview, i, 2 TO s: s = lcase$(trim$(s))
      IF s = "new balance" or s = "beginning balance" or i = numTransX then  
         LISTVIEW gET TEXT hMain, %IDC_MainListview, i, 3 to s: amt = val(trim$(s))
         listview get text hMain, %IDC_MainListview, i, 4 to sPaidBy
         listview get text hMain, %IDC_MainListview, i, 5 to sType
         balance = amt
         if sType = "Expense" or sType = "To fund" then balance = -amt
         s = alignCol(hMain, FORMAT$(balance, "0.00"), -75)
         LISTVIEW sET TEXT hMain, %IDC_MainListview, i, 6, s
         iTrx = i - 1: exit for
      end if      
   NEXT i
   'now, show the balances
   for i = iTrx to 1 step -1
      LISTVIEW gET TEXT hMain, %IDC_MainListview, i, 3 to s: amt = val(trim$(s))
      listview get text hMain, %IDC_MainListview, i, 4 to sPaidBy
      listview get text hMain, %IDC_MainListview, i, 5 to sType
      if sType = "Expense" or sType = "To fund" then amt = -amt 
      balance = balance + amt
      s = alignCol(hMain, FORMAT$(balance, "0.00"), -75)
      LISTVIEW sET TEXT hMain, %IDC_MainListview, i, 6, s
   next i   
END SUB                                                  

function alignCol(hDlg as long, sText as string, colWidth as long) as string
   'hDlg = handle of window containing the column
   'sText = text to be aligned in column
   'colWidth > 0 left align, column width in pixels
   'colWidth < 0 right align, column width in pixels
   '             ... assumes fixed width font for numbers
   'right align:  s = alignCol(hCtl, sText, -65) 
   '-------------------------------------------------------------------
   local hdc, hFont, nSpac, xSpac, xText as long
   LOCAL sz, spac AS ASCIIZ * 1024                         
   local fxd as string
   LOCAL t AS SIZEL                          
   hdc = GetDC(hDlg)
   if colWidth > 0 then
      hFont = SendMessage(hDlg, %WM_GETFONT, 0, 0)
   elseif colWidth < 0 then
      font new fxd, 9, 0, 0, 1 to hFont
   end if    
   SelectObject hdc, hFont
   spac = space$(1): GetTextExtentPoint32 hDC, spac, 1, t
   xSpac = t.cx
   sz = sText: GetTextExtentPoint32 hDC, sz, LEN(sz), t
   xText = t.cx
   nSpac = (abs(colWidth) - xText) / xSpac
   if colWidth > 0 then
      function = sText + space$(nSpac)
   elseif colWidth < 0 then
      function = space$(nSpac) + sText
   end if
end function                         

sub search()
   local hSearch, nStyle as long
   nStyle = nStyle = %WS_CAPTION OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Search", , , 250, 120, nStyle TO hSrch
   control add label, hSrch, -1, "Find:", 10, 22, 30, 16
   control add textbox, hSrch, %IDC_Find, "", 45, 20, 180, 22 
   control add button, hSrch, %IDC_Search, "Search", 80, 80, 70, 30
   control add button, hSrch, %IDCancel, "Cancel", 155, 80, 70, 30  
   DIALOG SHOW MODeless hSrch CALL searchProc
end sub                                                                         
                                                                                                     
callback function searchProc()
   local i, j, k, m, n as long
   local s, sDate, sPaidby, sFind as string
   local amt as single
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            case %IDC_Search
               dialog set text hMain, "Matching Transactions Found"                                                  
               control get text cb.hndl, %IDC_Find to sFind
               if len(sFind) = 0 then exit function else sFind = lcase$(sFind)
               control set text hMain, %IDC_ExitProg, "Back"
               dialog end cb.hndl 
               listview reset hMain, %IDC_MainListview
               for i = 1 to numTransX
                  k = transX(i).trxType                             
                  n = transX(i).date: s = TRIM$(STR$(n))
                  sDate =  MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
                  n = transX(i).paidBy: if n and n <= 5 then sPaidby = paidBy(n) else sPaidBy = ""
                  s = sDate + trim$(transX(i).nameID) + format$(transX(i).amount, "0.00") + sPaidBy
                  for m = 1 to transX(i).numTrxCatgs
                     n = transX(i).catg(m): amt = transX(i).catgAmt(m)
                     if k = 2 then
                        n = incOrder(n): s = s + incomes(n)
                     else 
                        n = expOrder(n): s = s + expenses(n)                 
                     end if                                        
                     s = s + format$(amt, "0.00")     
                  next j
                  if instr(lcase$(s), sFind) = 0 then iterate                                          
                  incr j: trx(j) = i
                  s = TRIM$(STR$(transX(i).date))                                
                  s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
                  LISTVIEW INSERT ITEM hMain, %IDC_MainListview, j, 0, s                       
                  s = alignCol(hMainListview, TRIM$(transX(i).nameID), 187)                                
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 2, s
                  s = alignCol(hMainListview, trim$(FORMAT$(transX(i).amount, "0.00")), -68)
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 3, s 
                  n = transX(i).paidBy: if n and n <= 5 then s = paidBy(n) else s = ""
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 4, s
                  k = transX(i).trxType
                  s = choose$(k, "Expense", "Income", "To fund", "From fund")                                                    
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 5, s
               next i   
            case %IDCancel
               dialog end cb.hndl
         end select
   end select   
end function
                       
sub filters()
   local i, j, j1, j2, j3, k, n, nStyle, x, y as long
   local s as string
   'nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   nStyle = nStyle = %WS_CAPTION OR %WS_SYSMENU OR %DS_MODALFRAME                                     
   DIALOG NEW PIXELS, hMain, "Transaction Filters", , , 620, 550, nStyle TO hFilter
   control add frame, hFilter, -1, "Dates", 10, 5, 120, 150
   control add option, hFilter, %IDC_FilterDate + 1, "This month", 20, 30, 100, 16
   control add option, hFilter, %IDC_FilterDate + 2, "Last month", 20, 50, 100, 16
   control add option, hFilter, %IDC_FilterDate + 3, "Three months", 20, 70, 100, 16
   control add option, hFilter, %IDC_FilterDate + 4, "Six months", 20, 90, 100, 16
   control add option, hFilter, %IDC_FilterDate + 5, "One year", 20, 110, 100, 16
   control add option, hFilter, %IDC_FilterDate + 6, "All time", 20, 130, 100, 16
   CONTROL SET OPTION hFilter, %IDC_FilterDate + 6, %IDC_FilterDate + 1, %IDC_FilterDate + 6 
   
   control add frame, hFilter, -1, "Flags/Types", 10, 165, 200, 110
   control add checkbox, hFilter, %IDC_Filter+0, "Essential", 20, 190, 80, 15 
   control add checkbox, hFilter, %IDC_Filter+1, "Fixed",     20, 210, 80, 15
   control add checkbox, hFilter, %IDC_Filter+2, "Automatic", 20, 230, 80, 15
   control add checkbox, hFilter, %IDC_Filter+3, "Expenses", 120, 190, 80, 15
   control add checkbox, hFilter, %IDC_Filter+4, "Incomes",  120, 210, 80, 15
   control add checkbox, hFilter, %IDC_Filter+5, "To fund",  120, 230, 80, 15
   control add checkbox, hFilter, %IDC_Filter+6, "From fund", 120, 250, 80, 15
   
   for i = 1 to maxExpenses
      n = expenses(i).catgNo
      n = expOrder(n)
      s = expenses(n).catgID
      incr j1: k = %IDC_Filter+6
      control add checkbox, hFilter, k + j1, s, 240, 10 + 20 * j1, 180, 15
   next i
   for i = 1 to maxIncomes
      n = incomes(i).catgNo
      s = incomes(n).catgID                     
      incr j2: k = %IDC_Filter+j1+6
      control add checkbox, hFilter, k + j2, s, 430, 10 + 20 * j2, 180, 15
   next i 
   j3 = j: j = max(j1, j2)   
   control add frame, hFilter, -1, "Expenses/Incomes", 230, 5, 380, 10 + 20 * (j + 1)
   dialog set size hFilter, 620, 100 + 20 * maxExpenses         
                                                
   j = max(j1, j2, j3)
   control add button, hFilter, %IDC_FilterClear, "Clear", 20, 300, 90, 30
   control add button, hFilter, %IDCancel, "Cancel", 20, 335, 90, 30  
   control add button, hFilter, %IDC_FilterShow, "Show", 20, 370, 90, 30
   CONTROL ADD STATUSBAR, hFilter, %IDC_Statusbar1, "", 0, 0, 0, 0
   STATUSBAR SET PARTS hFilter, %IDC_Statusbar1, 9999
   s = "Select option for dates, then check boxes for transactions to show"
   STATUSBAR SET TEXT hFilter, %IDC_Statusbar1, 1, 0, s
   DIALOG SHOW MODeless hFilter CALL filtersProc
   DO
    DIALOG DOEVENTS
    DIALOG GET SIZE hFilter TO x, y                   
   LOOP UNTIL ISFALSE (x * y)
end sub                       

callback function filtersProc()
   'long var filterBits() array uses 24 bits for each transaction
   'long var searchBits uses 34 bits for search
   'if filterBits(i) and searchBits then show ith transaction 
   '------------------------------------------------------------------
   local i, j, k, m, n, mo, yr as long
   local s as string
   static beginFilter as dword
   static searchBits, filterBits() as quad
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         dim filterBits(1 to numTransX) 
         for i = 1 to numTransX 
            filterBits(i) = 0                                                                  
            k = transX(i).trxType
            numTrxCatgs = transX(i).numTrxCatgs 
            for j = 1 to numTrxCatgs
               n = transX(i).catg(j)
               if k = 2 then 'incomes
                  n = incOrder(n) 
                  if incomes(n).Essn then bit set filterBits(i), 0
                  if incomes(n).Fixd then bit set filterBits(i), 1
                  if incomes(n).Auto then bit set filterBits(i), 2
                  bit set filterBits(i), n + 6 + maxExpenses
               else 'expenses                                                                   
                  n = expOrder(n)   
                  if expenses(n).Essn then bit set filterBits(i), 0
                  if expenses(n).Fixd then bit set filterBits(i), 1
                  if expenses(n).Auto then bit set filterBits(i), 2          
                  bit set filterBits(i), n + 6
               end if
            next j
            bit set filterBits(i), k + 2
         next i
         control set text hMain, %IDC_ExitProg, "Back"
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            case %IDC_FilterShow
               'first, get applicable date option
               mo = val(left$(date$, 2)): yr = val(right$(date$, 4))
               for i = 1 to 6
                  control get check cb.hndl, %IDC_FilterDate + i to n
                  if n then n = i: exit for 
               next i
               if n = 2 then 
                  decr mo: if mo = 0 then mo = 12: decr yr
               elseif n = 3 then
                  mo = mo - 3: if mo <= 0 then mo = mo + 12: decr yr
               elseif n = 4 then 
                  mo = mo - 6: if mo <= 0 then mo = mo + 12: decr yr
               elseif n = 5 then
                  decr mo: decr yr: if mo = 0 then mo = 12: decr yr:    
               elseif n = 6 then
                  mo = 0: yr = 0
               end if 
               beginFilter = yr * 10000 + mo * 100 + 1
               
               'now, get the checkboxes specifying the filter
               searchBits = 0
               dialog set text hMain, "Filtered Budget Transactions"
               for i = 0 to maxExpenses + maxIncomes + 6  '23
                  control get check cb.hndl, %IDC_Filter+i to n
                  if n then bit set searchBits, i
               next i
               listview reset hMain, %IDC_MainListview
               FOR i = 1 TO numTransX
                  if transX(i).date < beginFilter then iterate 
                  if (filterBits(i) and searchBits) = 0 then iterate
                  incr j: trx(j) = i
                  s = TRIM$(STR$(transX(i).date))                                
                  s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
                  LISTVIEW INSERT ITEM hMain, %IDC_MainListview, j, 0, s                       
                  s = alignCol(hMainListview, TRIM$(transX(i).nameID), 187)                                
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 2, s
                  s = alignCol(hMainListview, trim$(FORMAT$(transX(i).amount, "0.00")), -68)
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 3, s 
                  n = transX(i).paidBy: if n and n <= 5 then s = paidBy(n) else s = ""
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 4, s
                  k = transX(i).trxType
                  s = choose$(k, "Expense", "Income", "To fund", "From fund")                                                    
                  LISTVIEW SET TEXT hMain, %IDC_MainListview, j, 5, s
               NEXT i
               LISTVIEW SORT hMain, %IDC_MainListview, 1, DESCEND, MMDDYYYY
               control kill cb.hndl, %IDC_FilterShow
               control add button, cb.hndl, %IDC_FilterShow, "Show", 20, 370, 90, 30
               dialog hide cb.hndl
            case %IDC_FilterClear
               clearFilters()
               CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE   
            case %IDCancel
               dialog send cb.hndl, %WM_SYSCOMMAND, %SC_CLOSE, 0
         end select
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN 
            dialog end cb.hndl
            control set text hMain, %IDC_ExitProg, "Exit Program"
            CONTROL SEND hMain, %IDC_ExitProg, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         end if      
   end select         
end function                                                            

sub clearFilters()
   local i as long                                                
   for i = 0 to 31
      control set check hFilter, %IDC_Filter + i, 0
   next i
end sub

'========================================================================================
SUB settings()
   LOCAL i, n, nStyle AS LONG
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW PIXELS, hMain, "Settings", , , 480, 400, nStyle TO hSettings
   CONTROL ADD frame, hSettings, -1, "Catelogs", 10, 10, 100, 65
   CONTROL ADD OPTION, hSettings, %IDC_Opt1, "Expenses", 20, 30, 75, 15, %BS_NOTIFY OR %WS_GROUP OR %WS_TABSTOP
   CONTROL ADD OPTION, hSettings, %IDC_Opt2, "Incomes", 20, 50, 75, 15, %BS_NOTIFY
   CONTROL SET OPTION hSettings, %IDC_Opt1, %IDC_Opt1, %IDC_Opt2
   CONTROL ADD LABEL, hSettings, %IDC_OptText, "Expenses:", 150, 35, 50, 15
   nStyle = %CBS_DROPDOWN OR %WS_VSCROLL OR %WS_TABSTOP
   CONTROL ADD COMBOBOX, hSettings, %IDC_Catg, catg(), 150, 50, 180, 200, nStyle
   CONTROL ADD BUTTON, hSettings, %IDC_AddCatg, "Add", 197, 80, 50, 25
   CONTROL ADD BUTTON, hSettings, %IDC_ChgCatg, "Chg", 249, 80, 50, 25
   CONTROL ADD BUTTON, hSettings, %IDC_ResetCatgs, "Reset", 360, 50, 60, 25
   CONTROL ADD BUTTON, hSettings, %IDC_SettingsHelp, "?", 430, 50, 25, 25
   CONTROL ADD LABEL, hSettings, -1, "Flags: Essential, Fixed, Automatic", 8, 130, 200, 15
   nStyle = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %LVS_REPORT OR %LVS_SHOWSELALWAYS OR %LVS_SINGLESEL
   CONTROL ADD LISTVIEW, hSettings, %IDC_CatgFlags, "", 8, 150, 460, 232, nStyle, %WS_EX_CLIENTEDGE
   LISTVIEW SET STYLEXX hSettings, %IDC_CatgFlags, %LVS_EX_GRIDLINES 'Or %LVS_Ex_borderselect
   LISTVIEW INSERT COLUMN hSettings, %IDC_CatgFlags, 1, "Expense", 180, 0
   LISTVIEW INSERT COLUMN hSettings, %IDC_CatgFlags, 2, "Goal", 80, 2
   LISTVIEW INSERT COLUMN hSettings, %IDC_CatgFlags, 3, "Essen", 60, 2
   LISTVIEW INSERT COLUMN hSettings, %IDC_CatgFlags, 4, "Fixed", 60, 2
   LISTVIEW INSERT COLUMN hSettings, %IDC_CatgFlags, 5, "Auto ", 60, 2
   DIALOG SHOW MODAL hSettings CALL SettingsProc                                            
END SUB
              
CALLBACK FUNCTION SettingsProc()  
   LOCAL i, j, k, m, n , n1, n2, n3, n4, n5, maxCatgs AS LONG
   local s, ss, si as string
   'LOCAL s, s1, s2, s3, s4, s5, newCatg AS STRING     
   LOCAL addExpense AS tExpense, addIncome AS tIncome                  
   LOCAL LpLvNm AS NM_LISTVIEW PTR
   STATIC nCombo, kCombo AS LONG
   STATIC sCombo AS STRING                                                                  

   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         checkMark = CHR$$(10003)
         sCell = SPACE$(4) + checkMark + SPACE$(4)
         maxCols = 5
         DIM expGoals(1 TO maxExpenses), incGoals(1 TO maxIncomes)
         FOR i = 1 TO maxExpenses
            IF expenses(i).catgGoal THEN expGoals(i) = STR$(expenses(i).catgGoal)
         NEXT i
         FOR i = 1 TO maxIncomes
            IF incomes(i).catgGoal THEN incGoals(i) = STR$(incomes(i).catgGoal)
         NEXT i

         'Subclass the listview control so we can receive %WM_LButtonDown and %WM_KeyDown messages
         OldLVProc = SetWindowLongW(GetDlgItem(CB.HNDL, %IDC_CatgFlags), %GWL_WNDPROC, BYVAL CODEPTR(LVProc))

         DIALOG POST CB.HNDL, %WM_COMMAND, %IDC_Opt1, 0
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDC_Opt1
               nOpt = 1
               CONTROL SET OPTION hSettings, %IDC_Opt1, %IDC_Opt1, %IDC_Opt2
               CONTROL SET TEXT CB.HNDL, %IDC_OptText, "Expenses:"
               LISTVIEW SET HEADER CB.HNDL, %IDC_CatgFlags, 1, "Expense"
               'display goals and flags
               COMBOBOX RESET CB.HNDL, %IDC_Catg
               LISTVIEW RESET CB.HNDL, %IDC_CatgFlags
               maxRows = maxExpenses
               REDIM catg(1 TO maxExpenses)
               n = CB.HNDL: m = %IDC_CatgFlags
               FOR i = 1 TO maxRows
                  catg(i) = expenses(i).catgID
                  COMBOBOX ADD CB.HNDL, %IDC_Catg, catg(i)
                  LISTVIEW INSERT ITEM CB.HNDL, %IDC_CatgFlags, i, 0, catg(i)
                  n2 = expenses(i).catgGoal
                  IF n2 THEN 'display as centered in column 2
                     s = TRIM$(STR$(n2))
                     k = 8 - LEN(s): s = SPACE$(k) + s + SPACE$(k)
                  ELSE
                     s = SPACE$(16)
                  END IF
                  LISTVIEW SET TEXT n, m, i, 2, s
                  n3 = expenses(i).essn
                  IF n3 THEN sLV = sCell ELSE sLV = SPACE$(11)
                  LISTVIEW SET TEXT n, m, i, 3, sLV
                  n4 = expenses(i).fixd
                  IF n4 THEN sLV = sCell ELSE sLV = SPACE$(11) 
                  LISTVIEW SET TEXT n, m, i, 4, sLV
                  n5 = expenses(i).auto
                  IF n5 THEN sLV = sCell ELSE sLV = SPACE$(11)
                  LISTVIEW SET TEXT n, m, i, 5, sLV
               NEXT i
            CASE %IDC_Opt2
               nOpt = 2
               CONTROL SET OPTION hSettings, %IDC_Opt2, %IDC_Opt1, %IDC_Opt2
               CONTROL SET TEXT CB.HNDL, %IDC_OptText, "Incomes:"
               LISTVIEW SET HEADER CB.HNDL, %IDC_CatgFlags, 1, "Income"
               'display goals and flags
               COMBOBOX RESET CB.HNDL, %IDC_Catg
               LISTVIEW RESET CB.HNDL, %IDC_CatgFlags
               maxRows = maxIncomes
               REDIM catg(1 TO maxIncomes)
               n = CB.HNDL: m = %IDC_CatgFlags
               FOR i = 1 TO maxRows
                  catg(i) = incomes(i).catgID
                  COMBOBOX ADD CB.HNDL, %IDC_Catg, catg(i)
                  LISTVIEW INSERT ITEM CB.HNDL, %IDC_CatgFlags, i, 0, catg(i)
                  n2 = incomes(i).catgGoal
                  IF n2 THEN 'display as centered in column 2
                     s = TRIM$(STR$(n2))
                     k = 8 - LEN(s): s = SPACE$(k) + s + SPACE$(k)
                  ELSE
                     s = SPACE$(16)
                  END IF
                  LISTVIEW SET TEXT n, m, i, 2, s
                  LISTVIEW UNSELECT n, m, i, 2
                  n3 = incomes(i).essn
                  IF n3 THEN sLV = sCell ELSE sLV = SPACE$(11)
                  LISTVIEW SET TEXT n, m, i, 3, sLV
                  n4 = incomes(i).fixd
                  IF n4 THEN sLV = sCell ELSE sLV = SPACE$(11)
                  LISTVIEW SET TEXT n, m, i, 4, sLV
                  n5 = incomes(i).auto
                  IF n5 THEN sLV = sCell ELSE sLV = SPACE$(11)
                  LISTVIEW SET TEXT n, m, i, 5, sLV
               NEXT i
            CASE %IDC_AddCatg
               IF nCombo = 0 THEN
                  DIALOG SEND CB.HNDL, %DM_SETDEFID, %IDC_AddCatg, 0
                  COMBOBOX GET SELECT CB.HNDL, %IDC_Catg TO nCombo
                  control get text cb.hndl, %IDC_Catg to s
                  if nCombo > 0 then
                     CONTROL SET TEXT CB.HNDL, %IDC_Catg, ""
                  elseif len(s) then 'adding catg as last one
                     nCombo = -1: DIALOG SEND CB.HNDL, %WM_command, %IDC_AddCatg, 0
                  end if
                  CONTROL SET FOCUS CB.HNDL, %IDC_Catg
                  EXIT FUNCTION
               ELSE 'back to finish inserting new catg
                  CONTROL GET TEXT CB.HNDL, %IDC_Catg TO s
                  if nCombo > 0 then 
                     COMBOBOX INSERT CB.HNDL, %IDC_Catg, nCombo, s
                  elseif nCombo = -1 then
                     nCombo = maxExpenses + 1
                     combobox add cb.hndl, %IDC_Catg, s
                  end if
               END IF
               ss = lcase$(trim$(s))
               IF nOpt = 1 THEN
                  for i = 1 to maxExpenses
                     si = lcase$(trim$(expenses(i).catgID))
                     if ss = si then n = i: exit for
                  next    
                  if n > 0 then
                     msgbox "Not a unique category", %MB_iconinformation, ss: exit function
                  end if   
                  addExpense.catgID = s
                  addExpense.catgNo = maxExpenses + 1
                  n = %IDC_Opt1: INCR maxExpenses
                  REDIM PRESERVE expenses(1 TO maxExpenses)
                  REDIM PRESERVE expGoals(1 TO maxExpenses)
                  ARRAY INSERT expenses(nCombo), addExpense
               ELSE                                                     
                  for i = 1 to maxIncomes
                     si = lcase$(trim$(incomes(i).catgID))
                     if ss = si then n = i: exit for
                  next    
                  if n > 0 then
                     msgbox "Not a unique category", %MB_iconinformation, ss: exit function
                  end if   
                  addIncome.catgID = s
                  addIncome.catgNo = maxIncomes + 1
                  n = %IDC_Opt2: INCR maxIncomes
                  REDIM PRESERVE incomes(1 TO maxIncomes)
                  REDIM PRESERVE incGoals(1 TO maxIncomes)
                  ARRAY INSERT incomes(nCombo), addIncome
               END IF
               nCombo = 0
               settingsChanged = 1
               DIALOG SEND CB.HNDL, %WM_COMMAND, n, 0
               CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            CASE %IDC_ChgCatg
               IF kCombo = 0 THEN
                  DIALOG SEND CB.HNDL, %DM_SETDEFID, %IDC_ChgCatg, 0
                  COMBOBOX GET SELECT CB.HNDL, %IDC_Catg TO kCombo
                  CONTROL GET TEXT CB.HNDL, %IDC_Catg TO s
                  CONTROL SET TEXT CB.HNDL, %IDC_Catg, RTRIM$(s)
                  COMBOBOX FIND EXACT CB.HNDL, %IDC_Catg, 1, s TO n
                  IF n = 0 THEN kCombo = 0
                  EXIT FUNCTION
               ELSE
                  CONTROL GET TEXT CB.HNDL, %IDC_Catg TO s
                  COMBOBOX SET TEXT CB.HNDL, %IDC_Catg, kCombo, TRIM$(s)
               END IF
               IF nOpt = 1 THEN
                  n = %IDC_Opt1
                  expenses(kCombo).catgID = s
               ELSE
                  n = %IDC_Opt2
                  incomes(kCombo).catgID = s
               END IF
               kCombo = 0
               settingsChanged = 1
               DIALOG SEND CB.HNDL, %WM_COMMAND, n, 0
               CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
            case %IDC_ResetCatgs
               s = "Be careful, this will reset your catelogs to their defaults" + $crlf _
                 + "... Your changes will be lost, are you sure you want to proceed?"
               n = msgbox(s, %mb_yesno or %mb_iconwarning, "Reset catelogs")
               if n = %IDno then exit function    
               openIniFile
               for i = 1 to maxExpenses: expenses(i).catgNo = i: next i 
               for i = 1 to maxIncomes: incomes(i).catgNo = i: next i
               for i = 1 to numTransX
                  'remove all transaction expenses with catgNo > 21                         
                  'remove all transaction incomes with catgNo > 7
                  k = transX(i).trxType                                             
                  n = transX(i).numTrxCatgs
                  for j = 1 to transX(i).numTrxCatgs        
                     m = transX(i).catg(j)
                     if (k = 2 and m > 7) or m > 21 then
                        LISTVIEW DELETE ITEM hAddTransX, %IDC_TrxCatgs, j
                        decr n     
                     end if                  
                  next j
                  transX(i).numTrxCatgs = n
               next i
               fileChanged = 1: catgOrder()
               if nOpt = 1 then n = %IDC_Opt1 else n = %IDC_Opt2
               DIALOG SEND CB.HNDL, %WM_COMMAND, n, 0
            CASE %IDOK 'the enter key triggers this
               IF nCol > 2 THEN 'already stored, just want to unselect it
                  LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
               ELSEIF nCol = 2 THEN
                  LISTVIEW GET TEXT hSettings, %IDC_CatgFlags, nRow, nCol TO s
                  s = trim$(s): k = 8 - LEN(s): s = SPACE$(k) + s + SPACE$(k)
                  LISTVIEW SET TEXT hSettings, %IDC_CatgFlags, nRow, nCol, s
                  LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
                  IF nOpt = 1 THEN
                     expenses(nrow).catgGoal = VAL(s)
                     expGoals(nRow) = s
                  ELSE
                     incomes(nRow).catgGoal = VAL(s)
                     incGoals(nRow) = s
                  END IF
                  sGoal = "": settingsChanged = 1
               END IF
            CASE %IDC_SettingsHelp
               appHelp helpFile, "Help for my Budget"
         END SELECT
      CASE %WM_DESTROY
         SetWindowLongW(GetDlgItem(CB.HNDL, %IDC_CatgFlags), %GWL_WNDPROC, OldLVProc)
      CASE %WM_SYSCOMMAND
         IF CB.CTL = %SC_CLOSE THEN 
            if settingsChanged then
               catgOrder(): fileChanged = 1
            end if
         END IF
   END SELECT
END FUNCTION

'Listview subclass for settings
FUNCTION LVProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
  LOCAL c AS LONG               'number of rows per page
  LOCAL s AS STRING             'holds checkmark
  LOCAL LVHT AS LVHITTESTINFO   'Contains information about a mouse clik on the ListView
  LOCAL sTemp AS WSTRING

  checkMark = CHR$$(10003)
  sCell = SPACE$(4) + checkMark + SPACE$(4)
  SELECT CASE AS LONG wMsg
    CASE %WM_LBUTTONDOWN
      lvht.pt.x = LO(WORD, lparam)   ' X coordinate of mouse left button down
      lvht.pt.y = HI(WORD, lparam)   ' Y coordinate of mouse left button down

      'Find the listview item and subitem at these X, Y coordinates
      SendMessageW(hwnd, %LVM_SUBITEMHITTEST, BYVAL 0, BYVAL VARPTR(LVHT))

      IF lvht.iItem <> -1 THEN 'found listview cell
         CONTROL SET FOCUS hSettings, %IDC_CatgFlags
         LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
         nRow = lVHT.iItem+1: nCol = LVHT.iSubItem+1
      ELSE
         EXIT FUNCTION
      END IF

      'We handled this message, so we need to return a zero
      'and not call the the original listview callback.
      IF nCol > 1 THEN LISTVIEW SELECT hSettings, %IDC_CatgFlags, nRow, nCol
      FUNCTION = 0: EXIT FUNCTION
   CASE %WM_KEYDOWN
      SELECT CASE AS LONG wParam
         CASE %VK_0 TO %VK_9, %VK_NUMPAD0 TO %VK_NUMPAD9, %VK_DECIMAL, %VK_BACK, %VK_DELETE, 190
            IF nCol = 2 THEN 'enter data for goals
               IF wParam = %VK_DECIMAL OR wParam = 190 THEN
                  sGoal = sGoal + "."
               ELSEIF wParam = %VK_BACK THEN
                  sGoal = LEFT$(sGoal, LEN(sGoal) - 1)
               ELSEIF wParam = %VK_DELETE THEN
                  sGoal = ""
               ELSEIF wParam >= %VK_0 AND wParam <= %VK_9 THEN
                  sGoal = sGoal + TRIM$(STR$(wParam - %VK_0))
               ELSEIF wParam >= %VK_NUMPAD0 AND wParam <= %VK_NUMPAD9 THEN
                  sGoal = sGoal + TRIM$(STR$(wParam - %VK_NUMPAD0))
               END IF
               LISTVIEW SET TEXT hSettings, %IDC_CatgFlags, nRow, nCol, sGoal
            END IF
         CASE %VK_SPACE
            IF nCol > 2 THEN
               LISTVIEW GET TEXT hSettings, %IDC_CatgFlags, nRow, nCol TO sTemp
               IF sTemp = sCell THEN sTemp = SPACE$(11) ELSE sTemp = sCell                
               LISTVIEW SET TEXT hSettings, %IDC_CatgFlags, nRow, nCol, sTemp
               IF nOpt = 1 THEN
                  if nCol = 3 then expenses(nRow).essn = len(trim$(sTemp))             
                  if nCol = 4 then expenses(nRow).fixd = len(trim$(sTemp))
                  if nCol = 5 then expenses(nRow).auto = len(trim$(sTemp))
               ELSE
                  IF nCol = 3 THEN incomes(nRow).essn = LEN(trim$(sTemp))
                  IF nCol = 4 THEN incomes(nRow).fixd = LEN(trim$(sTemp))
                  IF nCol = 5 THEN incomes(nRow).auto = LEN(trim$(sTemp))
               END IF
               settingsChanged = 1
            END IF
         CASE %VK_UP
            'navigate the listview selection up
            revertBackGoals()
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nRow > 1 THEN DECR nRow
         CASE %VK_DOWN
            'navigate the listview selection down
            revertBackGoals()
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nRow < maxRows THEN INCR nRow
         CASE %VK_RIGHT
            'navigate the listview selection right
            revertBackGoals()
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nCol < maxCols THEN INCR nCol
         CASE %VK_LEFT
            'navigate the listview selection left
            revertBackGoals()
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nCol > 2 THEN DECR nCol
         CASE %VK_PGUP
            'navigate the listview selection a page up
            revertBackGoals()
            c = SendMessageW(hWnd, %LVM_GETCOUNTPERPAGE, 0, 0)
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nRow > c THEN nRow = nRow - c ELSE nRow = 1
         CASE %VK_PGDN
            'navigate the listview selection a page down
            revertBackGoals()
            c = SendMessageW(hWnd, %LVM_GETCOUNTPERPAGE, 0, 0)
            LISTVIEW UNSELECT hSettings, %IDC_CatgFlags, nRow, nCol
            IF nRow < maxRows - c THEN nRow = nRow + c ELSE nRow = maxRows
      END SELECT
      LISTVIEW SELECT hSettings, %IDC_CatgFlags, nRow, nCol
      LISTVIEW VISIBLE hSettings, %IDC_CatgFlags, nRow
      ' We handled this message, so we need to return a zero
      ' and not call the the original listview callback.
      FUNCTION = 0: EXIT FUNCTION
  END SELECT
  'if we did not handle this message, pass the message on to the
  'original callback for the listview control.
  FUNCTION = CallWindowProcW(OldLVProc, hWnd, wMsg, wParam, lParam)
END FUNCTION

SUB revertBackGoals()
   'revert back to already stored goal (was stored at %IDOK)
   IF nCol = 2 AND nOpt = 1 THEN
      LISTVIEW SET TEXT hSettings, %IDC_CatgFlags, nRow, nCol, expGoals(nRow)
      sGoal = ""
   ELSEIF nCol = 2 AND nOpt = 2 THEN
      LISTVIEW SET TEXT hSettings, %IDC_CatgFlags, nRow, nCol, incGoals(nRow)
      sGoal = ""
   END IF
END SUB

'======================================================================================
GLOBAL hCal, today, thisMo, thisYr, result AS LONG

FUNCTION Calendar(OPT BYVAL hParent AS LONG) AS STRING
   'returns double clicked date as string
   'returns today's date with Enter key
   '------------------------------------------------------
   LOCAL nStyle AS LONG
   nStyle = %WS_POPUP OR %DS_MODALFRAME OR %CS_DBLCLKS
   DIALOG NEW PIXELS, hParent, "Calendar Example", , , 160, 160, nStyle TO hCal
   DIALOG SET COLOR hCal, %RGB_BLACK, %RGB_WHITE
   DIALOG SHOW MODAL hCal, CALL CalendarProc
   IF result THEN EXIT FUNCTION
   FUNCTION = FORMAT$(thisMo, "00") + "-" + FORMAT$(today, "00") + "-" + TRIM$(STR$(thisYr))
END FUNCTION

CALLBACK FUNCTION CalendarProc()
   LOCAL i, n, hFont, hFont1, hOrig, wi, ht, x, y, nCol, nRow, startDay, day AS LONG
   LOCAL s, ti, sMonth AS STRING
   LOCAL ps AS PAINTSTRUCT
   STATIC month, year, hdc AS LONG
   STATIC months() AS STRING
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         REDIM months(1 TO 12)
         ARRAY ASSIGN months() = "January", "February", "March", "April", "May", "June", _
                                 "July", "August", "September", "October", "November", "December"
         today = VAL(MID$(DATE$, 4, 2))
         thisMo = VAL(LEFT$(DATE$, 2))
         thisYr = VAL(RIGHT$(DATE$, 4))
         month = thisMo: year = thisYr
         DIALOG GET SIZE CB.HNDL TO wi, ht
         FONT NEW "font0", 9,0,0,1 TO hFont
         FONT NEW "font1", 12,0,0,1 TO hFont1
         CONTROL ADD LABEL, CB.HNDL, 9102, "<", 2, 0, 20, 20, %SS_NOTIFY
         CONTROL SET FONT CB.HNDL, 9102, hFont1
         CONTROL SET COLOR CB.HNDL, 9102, %RGB_BLACK, %RGB_WHITE
         CONTROL ADD LABEL, CB.HNDL, 9103, ">", 140, 0, 20, 20, %SS_NOTIFY OR %SS_RIGHT
         CONTROL SET FONT CB.HNDL, 9103, hFont1
         CONTROL SET COLOR CB.HNDL, 9103, %RGB_BLACK, %RGB_WHITE
         ti = " Su Mo Tu We Th Fr Sa "
         CONTROL ADD LABEL, CB.HNDL, 9101, ti, 2, 25, 156, 15
         CONTROL SET FONT CB.HNDL, 9101, hFont
         CONTROL SET COLOR CB.HNDL, 9101, %RGB_BLACK, %RGB_WHITE
         CONTROL ADD LINE, CB.HNDL, -1, "", 2, 40, wi-12, 1
         CONTROL ADD BUTTON, CB.HNDL, %IDCANCEL, "x", 145, 145, 15, 15, %BS_PUSHLIKE
         CONTROL ADD BUTTON, CB.HNDL, 9104, "@", 129, 145, 15, 15, %BS_PUSHLIKE
         CONTROL ADD LABEL, CB.HNDL, 9105, TRIM$(STR$(year)), 95, 145, 35, 15
         CONTROL SET FONT CB.HNDL, 9105, hFont
         CONTROL SET COLOR CB.HNDL, 9105, %RGB_BLACK, %RGB_WHITE
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0
      CASE %WM_USER + 500 'show dialog for first time
         InvalidateRect CBHNDL, BYVAL %NULL, 1
      CASE %WM_LBUTTONDOWN
         'move window by dragging
         SendMessage  CB.HNDL, %WM_NCLBUTTONDOWN, %HTCAPTION, 0
      CASE %WM_LBUTTONDBLCLK
         x = LO(WORD, CB.LPARAM)
         y = HI(WORD, CB.LPARAM)
         nCol = (x-2)/21: nRow = (y-38)/15
         startDay = dayOfWeek(month, year, 1)
         DO
            INCR n:
            IF n = 1 THEN IF nRow = 1 THEN day = nCol - startDay ELSE day = 7 - startDay
            IF n = 2 THEN day = day + nCol
            IF n > 2 THEN day = day + 7
         LOOP UNTIL n = nRow
         today = day: thisMo = month: thisYr = year
         DIALOG END CB.HNDL
      CASE %WM_PAINT
         BeginPaint CBHNDL, ps
         showMonth months(month)
         showDays month, year                                                                
         EndPaint CBHNDL, ps
      CASE %WM_COMMAND
         SELECT CASE CB.CTL
            CASE %IDCANCEL: result = -1: DIALOG END CB.HNDL, result
            CASE %IDOK: result = 0: DIALOG END CB.HNDL, result
            CASE 9102 'prior month
               DECR month: IF month < 1 THEN month = 12: DECR year
               CONTROL SET TEXT CB.HNDL, 9105, TRIM$(STR$(year))
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE 9103 'next month
               INCR month: IF month > 12 THEN month = 1: INCR year
               CONTROL SET TEXT CB.HNDL, 9105, TRIM$(STR$(year))
               InvalidateRect CBHNDL, BYVAL %NULL, 1
            CASE 9104 'back to today's month
               month = thisMo: year = thisYr
               CONTROL SET TEXT CB.HNDL, 9105, TRIM$(STR$(year))
               InvalidateRect CBHNDL, BYVAL %NULL, 1
         END SELECT
      CASE %WM_DESTROY
   END SELECT
END FUNCTION

SUB showMonth(sMonth AS STRING)
   LOCAL hdc, hFont1, hOrig, x, y, n AS LONG
   LOCAL s AS STRING
   hdc = GetDC(hCal)
   hFont1 = makeFont(hdc, "Courier New", 12)
   hOrig = SelectObject(hdc, hFont1)
   showText hdc, 20, 2, SPACE$(12), %WHITE, %BLUE
   n = strSize(hdc, sMonth)
   x = 20 + (120 - n)/2: y = 2
   showText hdc, x, y, sMonth, %WHITE, %BLUE
   SelectObject hdc, hOrig
END SUB

SUB showDays(mo AS LONG, yr AS LONG)
   LOCAL i, j, k, x, y, xx, yy, numDays, startDay, top, day AS LONG
   LOCAL hdc, hFont, hOrig, hBit, memdc AS LONG
   LOCAL sDay AS STRING
   hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "todayBM")
   hdc = GetDC(hCal)
   hFont = makeFont(hdc, "Courier New", 9)
   hOrig = SelectObject(hdc, hFont)
   SetTextColor hdc, %RGB_BLACK
   SetBkColor hdc, %RGB_WHITE
   numDays = daysInMonth(mo, yr)
   startDay = dayOfWeek(mo, yr, 1)
   top = 50: k = 3
   FOR i = 0 TO 5
      FOR j = startDay TO 6
         INCR day
         sDay = RSET$(TRIM$(STR$(day)), 3)
         x = 2 + 21*j: y = top + 15*i - 7
         IF day > numDays THEN sDay = SPACE$(6)         
         showText hdc, x, y, sDay
         IF day = today AND mo = thisMo AND yr = thisYr THEN 'need to circle today's date
            xx = x: yy = y
         END IF
         startDay = 0
      NEXT j
   NEXT i
   IF yy THEN 'now draw the circle on today's date
      memdc = CreateCompatibleDC(hdc)
      SelectObject memdc, hBit
      BitBlt hdc, xx+4, yy-3, 24, 24, memdc, 0, 0, %SRCAND
      DeleteDC memdc
      DeleteObject hBit
   END IF
   SelectObject hdc, hOrig
END SUB

SUB showText(hdc&, x&, y&, sText$, OPT BYVAL fg&, BYVAL bg&)
   'hdc is after selecting in the font (if different from the system font)
   'optional fg and be are foreground and background colors
   '---------------------------------------------------------
   IF fg& THEN SetTextColor hdc&, fg&
   IF bg& THEN SetBkColor hdc&, bg&
   TextOut hdc&, x&, y&, BYVAL STRPTR(sText$), LEN(sText$)               
END SUB           

FUNCTION dayOfWeek(month AS LONG, year AS LONG, day AS LONG) AS LONG
   'The AstroDay function defined here is a modified version
   '  of the Julian date formula used by astronomers.
   'http://support.microsoft.com/kb/q109451/
   'Sun = 0, Mon = 1, Tue = 2, ...
   '---------------------------------------------------------
   LOCAL astroDay AS LONG, y AS DOUBLE
   y = year + (month - 2.85) / 12
   astroDay = INT(INT(INT(367*y)-1.75*INT(y)+day) -0.75*INT(0.01*y))+1721119
   FUNCTION = (astroDay - 3) MOD 7
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days                              
END FUNCTION

'FUNCTION strSize(hdc AS LONG, s AS STRING, opt wi as long) AS LONG
'   'hdc is after selecting in the font
'   'return length of s in pixels
'   '--------------------------------------------
'   LOCAL sz AS ASCIIZ * 1024
'   LOCAL t AS SIZEL                                         
'   sz = s: GetTextExtentPoint32 hdc, sz, LEN(sz), t
'   if wi then function = t.cy else FUNCTION = t.cx
'END FUNCTION

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL descr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   '----------------------------------------------------------
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL BOLD AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(descr) THEN
      BOLD = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION


'===================================================================================================
function strSize(hDlg as long, s as string, opt byval wi as long) as long
   'hDlg: handle of the dialog window 
   'wi: return width in pixels else return length of s                                            
   '------------------------------------------------------------
   LOCAL hdc, hFont AS LONG
   local sz AS ASCIIZ * 1024                   
   LOCAL t AS SIZEL
   sz = s
   hdc = GetDC(hDlg)
   DIALOG SEND hDlg, %WM_GETFONT, 0, 0 TO hFont
   SelectObject hdc, hFont
   GetTextExtentPoint32 hDC, sz, LEN(sz), t
   ReleaseDC hDlg, hdc
   if wi then function = t.cy else function = t.cx
end function

function binarySrch(srch as string, arr() as string) as long
   'find index for srch string in a sorted string array                    
   'or negative index where a new string should be inserted
   'case does not matter, but must ascending sort
   '---------------------------------------------------------- 
   local i, low, high as long
   local s as string 
   low = lbound(arr): high = ubound(arr)
   s = lcase$(srch)
   while low <= high                                               
      i = (low + high)\2
      if lcase$(left$(arr(i), len(s))) = s then function = i: exit function
      if lcase$(left$(arr(i), len(s))) < s then low = i + 1 else high = i - 1
      if low > high then 
         function = -low
      elseif low = high then 
         if s = lcase$(left$(arr(low), len(s))) then  
            function = low
         elseif s > lcase$(left$(arr(low), len(s))) then
            function = -(low + 1) 
         else
            function = -low
         end if
         exit function
      end if
   wend   
end function

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

'===================================================================================================
SUB about()
   LOCAL hAbout AS LONG, s AS STRING
   DIALOG NEW hMain,"About myBudget",,, 220, 160, %WS_SYSMENU TO hAbout
   CONTROL ADD LABEL, hAbout, 9901, "myBudget", 50, 10, 80, 20
   CONTROL ADD LABEL, hAbout, 9902, " for Windows", 120, 13, 70, 10
   s = "Version " + $ver + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   CONTROL ADD LABEL, hAbout, 9903, s, 50, 45, 180, 30
   s = "chasdietz@verizon.net"
   CONTROL ADD LABEL, hAbout, 9904, s, 60, 80, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   s = "http://www.cgdsoftware.com"
   CONTROL ADD LABEL, hAbout, 9905, s, 60, 95, 140, 12, %SS_NOPREFIX OR %SS_NOTIFY
   CONTROL ADD IMAGE, hAbout, -1, "LibrList", 10, 10, 30, 30
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB

CALLBACK FUNCTION aboutProc()
   LOCAL hFont AS LONG
   LOCAL url, email AS ASCIIZ*64
   SELECT CASE CB.MSG
   CASE %WM_PAINT
      FONT NEW "MS Sans Serif", 14 TO hFont
      CONTROL SET COLOR CB.HNDL, 9901, %RED, -1
      CONTROL SET FONT CB.HNDL, 9901, hFont
      FONT NEW "MS Sans Serif", 10, 2 TO hFont
      CONTROL SET FONT CB.HNDL, 9902, hFont
      FONT NEW "MS Sans Serif", 10 TO hFont
      CONTROL SET FONT CB.HNDL, 9903, hFont
      CONTROL SET COLOR CB.HNDL, 9906, hFont, -1
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9904, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9904, hFont
      FONT NEW "MS Sans Serif", 10, 4 TO hFont
      CONTROL SET COLOR CB.HNDL, 9905, %BLUE, -1
      CONTROL SET FONT CB.HNDL, 9905, hFont
      FONT END hFont
   CASE %WM_SETCURSOR  'Change cursor to hand when hovering over label
      IF GetDlgCtrlId(CBWPARAM) >= 9904 THEN
         SetCursor LoadCursor(GetModuleHandle(""), "HAND")
         SetWindowLong CB.HNDL, %DWL_MSGRESULT, 1: FUNCTION = 1
      END IF
   CASE %WM_COMMAND
      IF CB.CTL = %IDOK OR CB.CTL = %IDCANCEL THEN
         DIALOG END CB.HNDL
      ELSEIF CB.CTL = 9904 THEN
         MOUSEPTR 11
         email = "chasdietz@verizon.net"
         ShellExecute(0, "open", "mailto:" + email + "?", "", "", %SW_SHOW)
      ELSEIF CB.CTL = 9905 THEN
         MOUSEPTR 11
         url = "http://www.cgdsoftware.com"
         ShellExecute(BYVAL %NULL, "open", url, BYVAL %NULL, BYVAL %NULL,%SW_SHOWMAXIMIZED)
      END IF
   END SELECT
END FUNCTION
