'ver 1.01 5-15-2020        
' - beginning source code for myBudget        
 '- settings stored with csv records
'ver 1.02 5-27-2020
' - settings stored with TYPE records
' - included 1-month calendar
'ver 1.03 6-7-2020
' - added code for using main listview
' - added code for balances in column 6
' - added code for aligning columns 2, 3, and 6
'ver 1.04 6-18-2020 
' - added funds using the paidBy field
' - added SUB showFunds()
' - double click transaction list for categories
'ver 1.05 6-20-2020
' - changed funds from paidBy to trxType field
' - four trxType options: Expense, Income, To fund, From fund
'ver 1.06 6-25-2020
' - added auto-fill feature for faster data entry of transaction name
' - auto-fill keeps duplicate names consistant
'ver 1.07 6-26-2020
' - call openThisFile if thisFile exists
'   else call openIniFile and saveThisFile if it doesn't
'ver 1.08 6-29-2020
' - added filters() for showing different data combinations
' - Show data for last transaction of auto-filled nameID
'ver 1.09 6-30-2020
' - added search() showing matching transactions for specified text
' - saved this ver with default font of "Arial", 8
'ver 1.10 7-3-2020
' - enlarged font to "Arial", 10 (had to resize dialogs and controls)
' - prohibit catgs and their majors to both be used in a transaction
'ver 1.11 7-27-2020
' - revised two level categories to just a single level (no majors, minors)
' - only allow category additions and changes, no deletions in settings
' - eliminated possibility of duplicate categories in settings
' - added reset button in settings (data file back to default categories)
'------------------------------------------------------------------------------------- 

'Coming attractions
' - vertical scroll bar on filter 
' - showing transaction nameID after 2nd character - put inside textbox, not above
' - print budget transactions and analysis
' - truncate transactions
'-------------------------------------------------------------------------------------

'main dialog    
%IDC_MainListview  = 101
%IDC_AddTransX     = 102
%IDC_EdtTransX     = 103
%IDC_DelTransX     = 104
%IDC_ShowTrxCatgs  = 105
%IDC_ShowFunds     = 106
%IDC_Analysis      = 107
%IDC_ExitProg      = 108
%IDC_Statusbar     = 120

'addTransX dialog
%IDC_Opt1          = 131
%IDC_Opt2          = 132
%IDC_Opt3          = 133
%IDC_Opt4          = 134
%IDC_AddCatgs      = 141
%IDC_TrxCatgs      = 142
%IDC_LVMask        = 143
%IDC_TrxHelp       = 144
%IDC_Date          = 151
%IDC_CalendarImg   = 152
%IDC_TransXID      = 153
%IDC_Dummy         = 154
%IDC_TransXAmt     = 155
%IDC_PaidBy        = 156
%IDC_AddData       = 157
%IDC_RemoveCatg    = 158

'fund dialog
%IDC_ByDate        = 162
%IDC_ByCatg        = 163

'Settings dialog
%IDC_OptText       = 173                            
%IDC_Catg          = 174
%IDC_AddCatg       = 175 
%IDC_ChgCatg       = 176
%IDC_ResetCatgs    = 177
%IDC_SettingsHelp  = 178
%IDC_CatgFlags     = 190

'filters dialog
%IDC_Filter        = 200
%IDC_FilterDate    = 250
%IDC_FilterClear   = 291
%IDC_FilterShow    = 292
%IDC_StatusBar1    = 293

'search dialog
%IDC_Find          = 295
%IDC_Search        = 296
%IDC_EnterKey      = 299

'menu, files
%IDM_New           = 901
%IDM_Open          = 902
%IDM_Save          = 903
%IDM_SaveAs        = 904
%IDM_Print         = 905
%IDM_Settings      = 906
%IDM_Truncate      = 907
%IDM_Exit          = 908

'menu, transactions
%IDM_AddTransX     = 921
%IDM_EdtTransX     = 922                                      
%IDM_DelTransX     = 922

'menu, tasks
%IDM_ShowTrxCatgs  = 931
%IDM_ShowFunds     = 932
%IDM_Search        = 933
%IDM_TrxFilters    = 934
%IDM_Analysis      = 935
%IDM_YrSummary     = 936                  

'menu, help
%IDM_Help          = 951
%IDM_About         = 952

type tTransX
   date             as long                                         
   nameID           as string *40
   amount           as single       
   paidBy           as byte         'cash = 1, check = 2, debit card = 3, credit card = 4, govn issued = 5
   trxType          as byte         'expense = 1, income = 2, toFund = 3, fromFund = 4
   numTrxCatgs      as byte         'number of catgs picked for each transX, between 1 and 8
   catg(1 to 4)     as byte         'up to 4 categories can be used for each transaction
   catgAmt(1 to 4)  as single       'corresponding category amounts
   future           as string *20  
end type
                                   
type tExpense
   catgID        as string *29
   catgNo        as long
   catgGoal      as long
   Essn          as byte
   Fixd          as byte                                                                                                 
   Auto          as byte
end type

type tIncome
   catgID        as string *29
   catgNo        as long
   catgGoal      as long                        
   essn          as byte
   fixd          as byte                                                                           
   auto          as byte                                                                                             
end type                                   
                                                         
global nDebug as long
global hMain, hMainListview, hMenu, hFileMenu, hEditMenu, hTrxMenu, hTaskMenu, hHelpMenu, hSrch as long 
global hAccel, hSettings, hAddTransX, hTrxCatgs, hShowTrxCatgs, hShowFunds, hFilter, OldLVProc as long
global maxRows, maxCols, nRow, nCol, nOpt, numView, numFiles, fileChanged, settingsChanged as long
global numTransX, numTrxCatgs, numTransXID, numFunds, maxExpenses, maxIncomes as long
global amtLocked, hTransXID, hTransXAmt, hTrxCatgs as long
global fundBalance as single                                                 
global trx(), expOrder(), incOrder() as long                                                                               
global iniFile, thisFile, helpFile, progFolder, dataFolder, sGoal, sAmt, sOrigGoal as string
global dataFiles(), catg(), trxCatg(), expGoals(), incGoals(), expAmts(), incAmts(), paidBy() as string
global transXID() as string 'for completing transaction names
global checkMark, sCell, sLV as wstring
global expenses() as tExpense             
global incomes() as tIncome 
global transX() as tTransX
                                                               